// Generated with g9.

package edu.iastate.sdmay2025.corporateusers;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.distributioncenters.DistributionCenters;
import edu.iastate.sdmay2025.distributors.Distributors;
import edu.iastate.sdmay2025.finalizedpurchases.FinalizedPurchases;
import edu.iastate.sdmay2025.shoppingcartitems.ShoppingCartItems;

@Entity(name="corporate_users")
public class CorporateUsers implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(length=1)
    private boolean deleted;
    @Column(name="internal_on_hand", length=1)
    private boolean internalOnHand;
    @Column(name="ignore_price_and_cost", length=1)
    private boolean ignorePriceAndCost;
    @Column(nullable=false, length=1)
    private boolean archived;
    @OneToMany(mappedBy="corporateUsers")
    private Set<ShoppingCartItems> shoppingCartItems;
    @OneToMany(mappedBy="corporateUsers")
    private Set<FinalizedPurchases> finalizedPurchases;
    @OneToMany(mappedBy="corporateUsers")
    private Set<Distributors> distributors;
    @ManyToOne
    @JoinColumn(name="distribution_center_id")
    private DistributionCenters distributionCenters;

    /** Default constructor. */
    public CorporateUsers() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for internalOnHand.
     *
     * @return true if and only if internalOnHand is currently true
     */
    public boolean isInternalOnHand() {
        return internalOnHand;
    }

    /**
     * Setter method for internalOnHand.
     *
     * @param aInternalOnHand the new value for internalOnHand
     */
    public void setInternalOnHand(boolean aInternalOnHand) {
        internalOnHand = aInternalOnHand;
    }

    /**
     * Access method for ignorePriceAndCost.
     *
     * @return true if and only if ignorePriceAndCost is currently true
     */
    public boolean isIgnorePriceAndCost() {
        return ignorePriceAndCost;
    }

    /**
     * Setter method for ignorePriceAndCost.
     *
     * @param aIgnorePriceAndCost the new value for ignorePriceAndCost
     */
    public void setIgnorePriceAndCost(boolean aIgnorePriceAndCost) {
        ignorePriceAndCost = aIgnorePriceAndCost;
    }

    /**
     * Access method for archived.
     *
     * @return true if and only if archived is currently true
     */
    public boolean isArchived() {
        return archived;
    }

    /**
     * Setter method for archived.
     *
     * @param aArchived the new value for archived
     */
    public void setArchived(boolean aArchived) {
        archived = aArchived;
    }

    /**
     * Access method for shoppingCartItems.
     *
     * @return the current value of shoppingCartItems
     */
    public Set<ShoppingCartItems> getShoppingCartItems() {
        return shoppingCartItems;
    }

    /**
     * Setter method for shoppingCartItems.
     *
     * @param aShoppingCartItems the new value for shoppingCartItems
     */
    public void setShoppingCartItems(Set<ShoppingCartItems> aShoppingCartItems) {
        shoppingCartItems = aShoppingCartItems;
    }

    /**
     * Access method for finalizedPurchases.
     *
     * @return the current value of finalizedPurchases
     */
    public Set<FinalizedPurchases> getFinalizedPurchases() {
        return finalizedPurchases;
    }

    /**
     * Setter method for finalizedPurchases.
     *
     * @param aFinalizedPurchases the new value for finalizedPurchases
     */
    public void setFinalizedPurchases(Set<FinalizedPurchases> aFinalizedPurchases) {
        finalizedPurchases = aFinalizedPurchases;
    }

    /**
     * Access method for distributors.
     *
     * @return the current value of distributors
     */
    public Set<Distributors> getDistributors() {
        return distributors;
    }

    /**
     * Setter method for distributors.
     *
     * @param aDistributors the new value for distributors
     */
    public void setDistributors(Set<Distributors> aDistributors) {
        distributors = aDistributors;
    }

    /**
     * Access method for distributionCenters.
     *
     * @return the current value of distributionCenters
     */
    public DistributionCenters getDistributionCenters() {
        return distributionCenters;
    }

    /**
     * Setter method for distributionCenters.
     *
     * @param aDistributionCenters the new value for distributionCenters
     */
    public void setDistributionCenters(DistributionCenters aDistributionCenters) {
        distributionCenters = aDistributionCenters;
    }

    /**
     * Compares the key for this instance with another CorporateUsers.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class CorporateUsers and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof CorporateUsers)) {
            return false;
        }
        CorporateUsers that = (CorporateUsers) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another CorporateUsers.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof CorporateUsers)) return false;
        return this.equalKeys(other) && ((CorporateUsers)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[CorporateUsers |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
