// Generated with g9.

package edu.iastate.sdmay2025.distributioncentersskus;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Version;

import edu.iastate.sdmay2025.distributioncenters.DistributionCenters;
import edu.iastate.sdmay2025.inventorysnapshots.InventorySnapshots;
import edu.iastate.sdmay2025.shoppingcartitems.ShoppingCartItems;
import edu.iastate.sdmay2025.skus.Skus;

@Entity
@Table(name="distribution_centers_skus", indexes={@Index(name="distributionCentersSkusUniqueSkuAndDistributionCenter", columnList="sku_id,distribution_center_id", unique=true)})
public class DistributionCentersSkus implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=19)
    private long id;
    @Column(nullable=false, length=1)
    private boolean deleted;
    @Column(length=1)
    private boolean archived;
    @ManyToOne(optional=false)
    @JoinColumn(name="sku_id", nullable=false)
    private Skus skus;
    @OneToMany(mappedBy="distributionCentersSkus")
    private Set<ShoppingCartItems> shoppingCartItems;
    @ManyToOne(optional=false)
    @JoinColumn(name="distribution_center_id", nullable=false)
    private DistributionCenters distributionCenters;
    @OneToMany(mappedBy="distributionCentersSkus")
    private Set<InventorySnapshots> inventorySnapshots;

    /** Default constructor. */
    public DistributionCentersSkus() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public long getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(long aId) {
        id = aId;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for archived.
     *
     * @return true if and only if archived is currently true
     */
    public boolean isArchived() {
        return archived;
    }

    /**
     * Setter method for archived.
     *
     * @param aArchived the new value for archived
     */
    public void setArchived(boolean aArchived) {
        archived = aArchived;
    }

    /**
     * Access method for skus.
     *
     * @return the current value of skus
     */
    public Skus getSkus() {
        return skus;
    }

    /**
     * Setter method for skus.
     *
     * @param aSkus the new value for skus
     */
    public void setSkus(Skus aSkus) {
        skus = aSkus;
    }

    /**
     * Access method for shoppingCartItems.
     *
     * @return the current value of shoppingCartItems
     */
    public Set<ShoppingCartItems> getShoppingCartItems() {
        return shoppingCartItems;
    }

    /**
     * Setter method for shoppingCartItems.
     *
     * @param aShoppingCartItems the new value for shoppingCartItems
     */
    public void setShoppingCartItems(Set<ShoppingCartItems> aShoppingCartItems) {
        shoppingCartItems = aShoppingCartItems;
    }

    /**
     * Access method for distributionCenters.
     *
     * @return the current value of distributionCenters
     */
    public DistributionCenters getDistributionCenters() {
        return distributionCenters;
    }

    /**
     * Setter method for distributionCenters.
     *
     * @param aDistributionCenters the new value for distributionCenters
     */
    public void setDistributionCenters(DistributionCenters aDistributionCenters) {
        distributionCenters = aDistributionCenters;
    }

    /**
     * Access method for inventorySnapshots.
     *
     * @return the current value of inventorySnapshots
     */
    public Set<InventorySnapshots> getInventorySnapshots() {
        return inventorySnapshots;
    }

    /**
     * Setter method for inventorySnapshots.
     *
     * @param aInventorySnapshots the new value for inventorySnapshots
     */
    public void setInventorySnapshots(Set<InventorySnapshots> aInventorySnapshots) {
        inventorySnapshots = aInventorySnapshots;
    }

    /**
     * Gets the group fragment id for member skus.
     *
     * @return Current value of the group fragment
     * @see Skus
     */
    public long getSkusId() {
        return (getSkus() == null ? null : getSkus().getId());
    }

    /**
     * Sets the group fragment id from member skus.
     *
     * @param aId New value for the group fragment
     * @see Skus
     */
    public void setSkusId(long aId) {
        if (getSkus() != null) {
            getSkus().setId(aId);
        }
    }

    /**
     * Gets the group fragment id for member distributionCenters.
     *
     * @return Current value of the group fragment
     * @see DistributionCenters
     */
    public int getDistributionCentersId() {
        return (getDistributionCenters() == null ? null : getDistributionCenters().getId());
    }

    /**
     * Sets the group fragment id from member distributionCenters.
     *
     * @param aId New value for the group fragment
     * @see DistributionCenters
     */
    public void setDistributionCentersId(int aId) {
        if (getDistributionCenters() != null) {
            getDistributionCenters().setId(aId);
        }
    }

    /**
     * Compares the key for this instance with another DistributionCentersSkus.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class DistributionCentersSkus and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof DistributionCentersSkus)) {
            return false;
        }
        DistributionCentersSkus that = (DistributionCentersSkus) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another DistributionCentersSkus.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof DistributionCentersSkus)) return false;
        return this.equalKeys(other) && ((DistributionCentersSkus)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = (int)(getId() ^ (getId()>>>32));
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[DistributionCentersSkus |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Long.valueOf(getId()));
        return ret;
    }

}
