package edu.iastate.sdmay2025.distributors;

import java.math.BigDecimal;

import javax.persistence.Entity;


/**
 * Data Transfer Object to hold the products a distributor has.
 * 
 * Dist ID, Dist Name, Product Name, Brand Name, Sku ID, Distributor Base Sku Id, Cost Of Goods
 * 
 * @author Andrew Smith
 */
public class DistributorProductsDto {
	
	private int DistID;
	
	private String DistName;
	
	private String ProductName;
	
	private String BrandName;
	
	private long SkuID;
	
	private int DistBaseSkuID;
	
	private BigDecimal CostOfGoods;
	
	private BigDecimal onHandInventoryTargetLevel;
	
	private String SizeName;
	
	private int qtyToOrder;
	
	public DistributorProductsDto() {
		
	}
	
	public DistributorProductsDto(int DistID, String DistName, String ProductName, String BrandName, long SkuID, int DistBaseSkuID, BigDecimal CostOfGoods, BigDecimal onHandInventoryTargetLevel, BigDecimal NumberOfPacks, String PackName, BigDecimal Units, BigDecimal SizeOfMeasurement, String UnitOfMeasurement, String ProductSizeName) {
		this.DistID = DistID;
		this.DistName = DistName;
		this.ProductName = ProductName;
		this.BrandName = BrandName;
		this.SkuID = SkuID;
		this.DistBaseSkuID = DistBaseSkuID;
		this.CostOfGoods = CostOfGoods;
		this.onHandInventoryTargetLevel = onHandInventoryTargetLevel;
		if(!PackName.isEmpty()) 
			SizeName = NumberOfPacks + " " + PackName + " of " + Units + " - " + SizeOfMeasurement + " " + UnitOfMeasurement + " " + ProductSizeName;
		else
			SizeName = Units + " - " + SizeOfMeasurement + " " + UnitOfMeasurement + " " + ProductSizeName;
		if(SizeName.contains("Needs Size"))
			SizeName = "Needs Size";
	}

	public String getDistName() {
		return DistName;
	}

	public void setDistName(String distName) {
		DistName = distName;
	}

	public String getProductName() {
		return ProductName;
	}

	public void setProductName(String productName) {
		ProductName = productName;
	}

	public String getBrandName() {
		return BrandName;
	}

	public void setBrandName(String brandName) {
		BrandName = brandName;
	}

	public long getSkuID() {
		return SkuID;
	}

	public void setSkuID(long skuID) {
		SkuID = skuID;
	}

	public int getDistBaseSkuID() {
		return DistBaseSkuID;
	}

	public void setDistBaseSkuID(int distBaseSkuID) {
		DistBaseSkuID = distBaseSkuID;
	}
	
	public int getDistID() {
		return DistID;
	}

	public void setDistID(int distID) {
		DistID = distID;
	}

	public BigDecimal getCostOfGoods() {
		return CostOfGoods;
	}

	public void setCostOfGoods(BigDecimal costOfGoods) {
		CostOfGoods = costOfGoods;
	}

	public BigDecimal getOnHandInventoryTargetLevel() {
		return onHandInventoryTargetLevel;
	}

	public void setOnHandInventoryTargetLevel(BigDecimal onHandInventoryTargetLevel) {
		this.onHandInventoryTargetLevel = onHandInventoryTargetLevel;
	}
	
	public String getSizeName() {
		return SizeName;
	}

	public void setSizeName(String SizeName) {
		this.SizeName = SizeName;
	}

	public int getQtyToOrder() {
		return qtyToOrder;
	}

	public void setQtyToOrder(int qtyToOrder) {
		this.qtyToOrder = qtyToOrder;
	}

}
