package edu.iastate.sdmay2025.distributors;

import java.util.Date;

/**
 * Data Transfer Object to hold the distributors order and delivery schedule.
 * 
 * Dist id; name; order_day 0=Sunday, 1=Monday,...; week_basis Every 1 week, Every 2 weeks,...; days_to_delivery least amount of time to deliver; days_to_delivery_end most amount of time to deliver; start_date gets set once so if it's every 3 weeks we know what date it started. 
 * 
 * @author Andrew Smith
 */
public class DistributorScheduleDTO {
	
	private int id;
	
	private String name;
	
	private int weekBasis;
	
	private int daysToDelivery;
	
	private int daysToDeliveryEnd;
	
	public DistributorScheduleDTO() {
		
	}
	
	public DistributorScheduleDTO(int id, String name, int weekBasis, int daysToDelivery, int daysToDeliveryEnd) {
		this.id = id;
		this.name = name;
		this.weekBasis = weekBasis;
		this.daysToDelivery = daysToDelivery;
		this.daysToDeliveryEnd = daysToDeliveryEnd;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getWeekBasis() {
		return weekBasis;
	}

	public void setWeekBasis(int weekBasis) {
		this.weekBasis = weekBasis;
	}

	public int getDaysToDelivery() {
		return daysToDelivery;
	}

	public void setDaysToDelivery(int daysToDelivery) {
		this.daysToDelivery = daysToDelivery;
	}

	public int getDaysToDeliveryEnd() {
		return daysToDeliveryEnd;
	}

	public void setDaysToDeliveryEnd(int daysToDeliveryEnd) {
		this.daysToDeliveryEnd = daysToDeliveryEnd;
	}

}