// Generated with g9.

package edu.iastate.sdmay2025.distributors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import edu.iastate.sdmay2025.corporateusers.CorporateUsers;
import edu.iastate.sdmay2025.distributioncenters.DistributionCenters;
import edu.iastate.sdmay2025.distributionorderdays.DistributorOrderDays;
import edu.iastate.sdmay2025.inventorysubmissions.InventorySubmissions;
import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;

@SuppressWarnings("serial")
@Entity(name="distributors")
public class Distributors implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    private String name;
    @Column(name="order_minimum", precision=131089)
    private BigDecimal orderMinimum;
    @Column(length=1)
    private boolean deleted;
    @Column(name="internal_distributor", length=1)
    private boolean internalDistributor;
    @Column(name="menu_active", length=1)
    private boolean menuActive;
    @Column(length=1)
    private boolean monday;
    @Column(length=1)
    private boolean tuesday;
    @Column(length=1)
    private boolean wednesday;
    @Column(length=1)
    private boolean thursday;
    @Column(length=1)
    private boolean friday;
    @Column(name="exclude_from_financials", length=1)
    private boolean excludeFromFinancials;
    @Column(name="distributor_type", nullable=false, precision=10)
    private Integer distributorType;
    @Column(length=1)
    private boolean archived;
    @Column(precision=10)
    private Integer term; //complained about null values, changed int to Integer
    @Column(name="reorder_threshold", precision=10)
    private Integer reorderThreshold; // complained about setting null values, changed int to Integer
    @Column(name="reorder_amount", precision=10)
    private Integer reorderAmount; // complained about setting null values, changed int to Integer
    @Column(length=1)
    private boolean saturday;
    @Column(length=1)
    private boolean sunday;
    @Column(name="procurement_buffer", nullable=false, precision=131089)
    private BigDecimal procurementBuffer;
    @Column(name="operator_app", nullable=false, length=1)
    private boolean operatorApp;
    @OneToMany(mappedBy="distributors")
    private Set<InventorySubmissions> inventorySubmissions;
    @ManyToOne
    @JoinColumn(name="corporate_user_id")
    private CorporateUsers corporateUsers;
    @OneToMany(mappedBy="distributors")
    private Set<PurchasingSizes> purchasingSizes;
    @OneToMany(mappedBy="distributors")
    private Set<DistributorOrderDays> distributorOrderDays;
    @ManyToOne
    @JoinColumn(name="distribution_center_id")
    private DistributionCenters distributionCenters;

    /** Default constructor. */
    public Distributors() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for name.
     *
     * @return the current value of name
     */
    public String getName() {
        return name;
    }

    /**
     * Setter method for name.
     *
     * @param aName the new value for name
     */
    public void setName(String aName) {
        name = aName;
    }

    /**
     * Access method for orderMinimum.
     *
     * @return the current value of orderMinimum
     */
    public BigDecimal getOrderMinimum() {
        return orderMinimum;
    }

    /**
     * Setter method for orderMinimum.
     *
     * @param aOrderMinimum the new value for orderMinimum
     */
    public void setOrderMinimum(BigDecimal aOrderMinimum) {
        orderMinimum = aOrderMinimum;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for internalDistributor.
     *
     * @return true if and only if internalDistributor is currently true
     */
    public boolean isInternalDistributor() {
        return internalDistributor;
    }

    /**
     * Setter method for internalDistributor.
     *
     * @param aInternalDistributor the new value for internalDistributor
     */
    public void setInternalDistributor(boolean aInternalDistributor) {
        internalDistributor = aInternalDistributor;
    }

    /**
     * Access method for menuActive.
     *
     * @return true if and only if menuActive is currently true
     */
    public boolean isMenuActive() {
        return menuActive;
    }

    /**
     * Setter method for menuActive.
     *
     * @param aMenuActive the new value for menuActive
     */
    public void setMenuActive(boolean aMenuActive) {
        menuActive = aMenuActive;
    }

    /**
     * Access method for monday.
     *
     * @return true if and only if monday is currently true
     */
    public boolean isMonday() {
        return monday;
    }

    /**
     * Setter method for monday.
     *
     * @param aMonday the new value for monday
     */
    public void setMonday(boolean aMonday) {
        monday = aMonday;
    }

    /**
     * Access method for tuesday.
     *
     * @return true if and only if tuesday is currently true
     */
    public boolean isTuesday() {
        return tuesday;
    }

    /**
     * Setter method for tuesday.
     *
     * @param aTuesday the new value for tuesday
     */
    public void setTuesday(boolean aTuesday) {
        tuesday = aTuesday;
    }

    /**
     * Access method for wednesday.
     *
     * @return true if and only if wednesday is currently true
     */
    public boolean isWednesday() {
        return wednesday;
    }

    /**
     * Setter method for wednesday.
     *
     * @param aWednesday the new value for wednesday
     */
    public void setWednesday(boolean aWednesday) {
        wednesday = aWednesday;
    }

    /**
     * Access method for thursday.
     *
     * @return true if and only if thursday is currently true
     */
    public boolean isThursday() {
        return thursday;
    }

    /**
     * Setter method for thursday.
     *
     * @param aThursday the new value for thursday
     */
    public void setThursday(boolean aThursday) {
        thursday = aThursday;
    }

    /**
     * Access method for friday.
     *
     * @return true if and only if friday is currently true
     */
    public boolean isFriday() {
        return friday;
    }

    /**
     * Setter method for friday.
     *
     * @param aFriday the new value for friday
     */
    public void setFriday(boolean aFriday) {
        friday = aFriday;
    }

    /**
     * Access method for excludeFromFinancials.
     *
     * @return true if and only if excludeFromFinancials is currently true
     */
    public boolean isExcludeFromFinancials() {
        return excludeFromFinancials;
    }

    /**
     * Setter method for excludeFromFinancials.
     *
     * @param aExcludeFromFinancials the new value for excludeFromFinancials
     */
    public void setExcludeFromFinancials(boolean aExcludeFromFinancials) {
        excludeFromFinancials = aExcludeFromFinancials;
    }

    /**
     * Access method for distributorType.
     *
     * @return the current value of distributorType
     */
    public int getDistributorType() {
        return distributorType;
    }

    /**
     * Setter method for distributorType.
     *
     * @param aDistributorType the new value for distributorType
     */
    public void setDistributorType(int aDistributorType) {
        distributorType = aDistributorType;
    }

    /**
     * Access method for archived.
     *
     * @return true if and only if archived is currently true
     */
    public boolean isArchived() {
        return archived;
    }

    /**
     * Setter method for archived.
     *
     * @param aArchived the new value for archived
     */
    public void setArchived(boolean aArchived) {
        archived = aArchived;
    }

    /**
     * Access method for term.
     *
     * @return the current value of term
     */
    public Integer getTerm() {
        return term;
    }

    /**
     * Setter method for term.
     *
     * @param aTerm the new value for term
     */
    public void setTerm(Integer aTerm) {
        term = aTerm;
    }

    /**
     * Access method for reorderThreshold.
     *
     * @return the current value of reorderThreshold
     */
    public Integer getReorderThreshold() {
        return reorderThreshold;
    }

    /**
     * Setter method for reorderThreshold.
     *
     * @param aReorderThreshold the new value for reorderThreshold
     */
    public void setReorderThreshold(Integer aReorderThreshold) {
        reorderThreshold = aReorderThreshold;
    }

    /**
     * Access method for reorderAmount.
     *
     * @return the current value of reorderAmount
     */
    public Integer getReorderAmount() {
        return reorderAmount;
    }

    /**
     * Setter method for reorderAmount.
     *
     * @param aReorderAmount the new value for reorderAmount
     */
    public void setReorderAmount(Integer aReorderAmount) {
        reorderAmount = aReorderAmount;
    }

    /**
     * Access method for saturday.
     *
     * @return true if and only if saturday is currently true
     */
    public boolean isSaturday() {
        return saturday;
    }

    /**
     * Setter method for saturday.
     *
     * @param aSaturday the new value for saturday
     */
    public void setSaturday(boolean aSaturday) {
        saturday = aSaturday;
    }

    /**
     * Access method for sunday.
     *
     * @return true if and only if sunday is currently true
     */
    public boolean isSunday() {
        return sunday;
    }

    /**
     * Setter method for sunday.
     *
     * @param aSunday the new value for sunday
     */
    public void setSunday(boolean aSunday) {
        sunday = aSunday;
    }

    /**
     * Access method for procurementBuffer.
     *
     * @return the current value of procurementBuffer
     */
    public BigDecimal getProcurementBuffer() {
        return procurementBuffer;
    }

    /**
     * Setter method for procurementBuffer.
     *
     * @param aProcurementBuffer the new value for procurementBuffer
     */
    public void setProcurementBuffer(BigDecimal aProcurementBuffer) {
        procurementBuffer = aProcurementBuffer;
    }

    /**
     * Access method for operatorApp.
     *
     * @return true if and only if operatorApp is currently true
     */
    public boolean isOperatorApp() {
        return operatorApp;
    }

    /**
     * Setter method for operatorApp.
     *
     * @param aOperatorApp the new value for operatorApp
     */
    public void setOperatorApp(boolean aOperatorApp) {
        operatorApp = aOperatorApp;
    }

    /**
     * Access method for inventorySubmissions.
     *
     * @return the current value of inventorySubmissions
     */
    public Set<InventorySubmissions> getInventorySubmissions() {
        return inventorySubmissions;
    }

    /**
     * Setter method for inventorySubmissions.
     *
     * @param aInventorySubmissions the new value for inventorySubmissions
     */
    public void setInventorySubmissions(Set<InventorySubmissions> aInventorySubmissions) {
        inventorySubmissions = aInventorySubmissions;
    }

    /**
     * Access method for corporateUsers.
     *
     * @return the current value of corporateUsers
     */
    public CorporateUsers getCorporateUsers() {
        return corporateUsers;
    }

    /**
     * Setter method for corporateUsers.
     *
     * @param aCorporateUsers the new value for corporateUsers
     */
    public void setCorporateUsers(CorporateUsers aCorporateUsers) {
        corporateUsers = aCorporateUsers;
    }

    /**
     * Access method for purchasingSizes.
     *
     * @return the current value of purchasingSizes
     */
    public Set<PurchasingSizes> getPurchasingSizes() {
        return purchasingSizes;
    }

    /**
     * Setter method for purchasingSizes.
     *
     * @param aPurchasingSizes the new value for purchasingSizes
     */
    public void setPurchasingSizes(Set<PurchasingSizes> aPurchasingSizes) {
        purchasingSizes = aPurchasingSizes;
    }

    /**
     * Access method for distributorOrderDays.
     *
     * @return the current value of distributorOrderDays
     */
    public Set<DistributorOrderDays> getDistributorOrderDays() {
        return distributorOrderDays;
    }

    /**
     * Setter method for distributorOrderDays.
     *
     * @param aDistributorOrderDays the new value for distributorOrderDays
     */
    public void setDistributorOrderDays(Set<DistributorOrderDays> aDistributorOrderDays) {
        distributorOrderDays = aDistributorOrderDays;
    }

    /**
     * Access method for distributionCenters.
     *
     * @return the current value of distributionCenters
     */
    public DistributionCenters getDistributionCenters() {
        return distributionCenters;
    }

    /**
     * Setter method for distributionCenters.
     *
     * @param aDistributionCenters the new value for distributionCenters
     */
    public void setDistributionCenters(DistributionCenters aDistributionCenters) {
        distributionCenters = aDistributionCenters;
    }

    /**
     * Compares the key for this instance with another Distributors.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class Distributors and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof Distributors)) {
            return false;
        }
        Distributors that = (Distributors) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another Distributors.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof Distributors)) return false;
        return this.equalKeys(other) && ((Distributors)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[Distributors |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
