package edu.iastate.sdmay2025.distributors;

import java.math.BigDecimal;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import edu.iastate.sdmay2025.corporateusers.CorporateUsers;
import edu.iastate.sdmay2025.distributioncenters.DistributionCenters;
import edu.iastate.sdmay2025.distributionorderdays.DistributorOrderDays;
import edu.iastate.sdmay2025.inventorysubmissions.InventorySubmissions;
import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;

/**
 * Data Transfer Object to hold the products a distributor has.
 * 
 * Dist ID, Dist Name, Product Name, Brand Name, Sku ID, Distributor Base Sku Id, Cost Of Goods
 * 
 * @author Andrew Smith
 */
public class DistributorsOnlyWithProductsDTO {

	   private int id;
	   private String name;
	   private BigDecimal orderMinimum;
	   private boolean deleted;
	   private boolean internalDistributor;
	   private boolean menuActive;
	   private boolean monday;
	   private boolean tuesday;
	   private boolean wednesday;
	   private boolean thursday;
	   private boolean friday;
	   private boolean excludeFromFinancials;
	   private Integer distributorType;
	   private boolean archived;
	   private Integer term; 
	   private Integer reorderThreshold; 
	   private Integer reorderAmount; 
	   private boolean saturday;
	   private boolean sunday;
	   private BigDecimal procurementBuffer;
	   private boolean operatorApp;
	   private Set<InventorySubmissions> inventorySubmissions;
	   private CorporateUsers corporateUsers;
	   private Set<PurchasingSizes> purchasingSizes;
	   private Set<DistributorOrderDays> distributorOrderDays;
	   private DistributionCenters distributionCenters;
	
	public DistributorsOnlyWithProductsDTO() {
		
	}
	
	public DistributorsOnlyWithProductsDTO(int id) {

	}

	

}
