// Generated with g9.

package edu.iastate.sdmay2025.finalizedpurchases;

import java.io.Serializable;
import java.sql.Date;
import java.sql.Timestamp;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.corporateusers.CorporateUsers;
import edu.iastate.sdmay2025.misseditems.MissedItems;
import edu.iastate.sdmay2025.shoppingcartitems.ShoppingCartItems;

@Entity(name="finalized_purchases")
public class FinalizedPurchases implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(name="delivery_date")
    private Date deliveryDate;
    @Column(name="created_at")
    private Timestamp createdAt;
    @Column(name="updated_at")
    private Timestamp updatedAt;
    @Column(length=1)
    private boolean deleted;
    @Column(name="delivery_date_end")
    private Date deliveryDateEnd;
    @Column(name="pickup_date_end")
    private Date pickupDateEnd;
    @Column(name="procurement_default", length=1)
    private boolean procurementDefault;
    @Column(name="sent_to_distributor_at")
    private Timestamp sentToDistributorAt;
    @Column(name="order_status", nullable=false, precision=10)
    private int orderStatus;
    @ManyToOne
    @JoinColumn(name="corporate_user_id")
    private CorporateUsers corporateUsers;
    @OneToMany(mappedBy="finalizedPurchases")
    private Set<ShoppingCartItems> shoppingCartItems;
    @OneToMany(mappedBy="finalizedPurchases2")
    private Set<ShoppingCartItems> shoppingCartItems2;
    @OneToMany(mappedBy="finalizedPurchases")
    private Set<MissedItems> missedItems;

    /** Default constructor. */
    public FinalizedPurchases() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for deliveryDate.
     *
     * @return the current value of deliveryDate
     */
    public Date getDeliveryDate() {
        return deliveryDate;
    }

    /**
     * Setter method for deliveryDate.
     *
     * @param aDeliveryDate the new value for deliveryDate
     */
    public void setDeliveryDate(Date aDeliveryDate) {
        deliveryDate = aDeliveryDate;
    }

    /**
     * Access method for createdAt.
     *
     * @return the current value of createdAt
     */
    public Timestamp getCreatedAt() {
        return createdAt;
    }

    /**
     * Setter method for createdAt.
     *
     * @param aCreatedAt the new value for createdAt
     */
    public void setCreatedAt(Timestamp aCreatedAt) {
        createdAt = aCreatedAt;
    }

    /**
     * Access method for updatedAt.
     *
     * @return the current value of updatedAt
     */
    public Timestamp getUpdatedAt() {
        return updatedAt;
    }

    /**
     * Setter method for updatedAt.
     *
     * @param aUpdatedAt the new value for updatedAt
     */
    public void setUpdatedAt(Timestamp aUpdatedAt) {
        updatedAt = aUpdatedAt;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for deliveryDateEnd.
     *
     * @return the current value of deliveryDateEnd
     */
    public Date getDeliveryDateEnd() {
        return deliveryDateEnd;
    }

    /**
     * Setter method for deliveryDateEnd.
     *
     * @param aDeliveryDateEnd the new value for deliveryDateEnd
     */
    public void setDeliveryDateEnd(Date aDeliveryDateEnd) {
        deliveryDateEnd = aDeliveryDateEnd;
    }

    /**
     * Access method for pickupDateEnd.
     *
     * @return the current value of pickupDateEnd
     */
    public Date getPickupDateEnd() {
        return pickupDateEnd;
    }

    /**
     * Setter method for pickupDateEnd.
     *
     * @param aPickupDateEnd the new value for pickupDateEnd
     */
    public void setPickupDateEnd(Date aPickupDateEnd) {
        pickupDateEnd = aPickupDateEnd;
    }

    /**
     * Access method for procurementDefault.
     *
     * @return true if and only if procurementDefault is currently true
     */
    public boolean isProcurementDefault() {
        return procurementDefault;
    }

    /**
     * Setter method for procurementDefault.
     *
     * @param aProcurementDefault the new value for procurementDefault
     */
    public void setProcurementDefault(boolean aProcurementDefault) {
        procurementDefault = aProcurementDefault;
    }

    /**
     * Access method for sentToDistributorAt.
     *
     * @return the current value of sentToDistributorAt
     */
    public Timestamp getSentToDistributorAt() {
        return sentToDistributorAt;
    }

    /**
     * Setter method for sentToDistributorAt.
     *
     * @param aSentToDistributorAt the new value for sentToDistributorAt
     */
    public void setSentToDistributorAt(Timestamp aSentToDistributorAt) {
        sentToDistributorAt = aSentToDistributorAt;
    }

    /**
     * Access method for orderStatus.
     *
     * @return the current value of orderStatus
     */
    public int getOrderStatus() {
        return orderStatus;
    }

    /**
     * Setter method for orderStatus.
     *
     * @param aOrderStatus the new value for orderStatus
     */
    public void setOrderStatus(int aOrderStatus) {
        orderStatus = aOrderStatus;
    }

    /**
     * Access method for corporateUsers.
     *
     * @return the current value of corporateUsers
     */
    public CorporateUsers getCorporateUsers() {
        return corporateUsers;
    }

    /**
     * Setter method for corporateUsers.
     *
     * @param aCorporateUsers the new value for corporateUsers
     */
    public void setCorporateUsers(CorporateUsers aCorporateUsers) {
        corporateUsers = aCorporateUsers;
    }

    /**
     * Access method for shoppingCartItems.
     *
     * @return the current value of shoppingCartItems
     */
    public Set<ShoppingCartItems> getShoppingCartItems() {
        return shoppingCartItems;
    }

    /**
     * Setter method for shoppingCartItems.
     *
     * @param aShoppingCartItems the new value for shoppingCartItems
     */
    public void setShoppingCartItems(Set<ShoppingCartItems> aShoppingCartItems) {
        shoppingCartItems = aShoppingCartItems;
    }

    /**
     * Access method for shoppingCartItems2.
     *
     * @return the current value of shoppingCartItems2
     */
    public Set<ShoppingCartItems> getShoppingCartItems2() {
        return shoppingCartItems2;
    }

    /**
     * Setter method for shoppingCartItems2.
     *
     * @param aShoppingCartItems2 the new value for shoppingCartItems2
     */
    public void setShoppingCartItems2(Set<ShoppingCartItems> aShoppingCartItems2) {
        shoppingCartItems2 = aShoppingCartItems2;
    }

    /**
     * Access method for missedItems.
     *
     * @return the current value of missedItems
     */
    public Set<MissedItems> getMissedItems() {
        return missedItems;
    }

    /**
     * Setter method for missedItems.
     *
     * @param aMissedItems the new value for missedItems
     */
    public void setMissedItems(Set<MissedItems> aMissedItems) {
        missedItems = aMissedItems;
    }

    /**
     * Compares the key for this instance with another FinalizedPurchases.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class FinalizedPurchases and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof FinalizedPurchases)) {
            return false;
        }
        FinalizedPurchases that = (FinalizedPurchases) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another FinalizedPurchases.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof FinalizedPurchases)) return false;
        return this.equalKeys(other) && ((FinalizedPurchases)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[FinalizedPurchases |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
