package edu.iastate.sdmay2025.finalizedpurchases;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * REST Api Controller for the Finalized Purchases
 * 
 * @author Andrew Smith
 */
@RestController
@CrossOrigin(origins= {"*"})
public class FinalizedPurchasesController {
		
	@Autowired
	FinalizedPurchasesRepo FinalizedPurchasesRepo;
	
	@ResponseBody
	@RequestMapping(method = RequestMethod.GET, path="/missedItemsBySku/{sku}")
	public List<FinalizedPurchasesDTO> getMissedItemsBySku(@PathVariable long sku) {
		List<FinalizedPurchasesDTO> result = FinalizedPurchasesRepo.getMissedItemsBySku(sku);
		return result;
	}

}