package edu.iastate.sdmay2025.finalizedpurchases;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Date;


/**
 * Data Transfer Object to hold the historical missed sale items given a sku id
 * 
 *  dist_id #either the client or distributor id, client_name #the client name, order_date #the date the order was sent making the items missed sales, sku_id #the SKU id of the item missed, product_name #The product name, brandName #the brand of that product, sizeName #the size of the missed sale
 * 
 * @author Andrew Smith
 */
public class FinalizedPurchasesDTO {
	
	private Date orderDate;
	
	private int missedCount;
	
	private long skuID;
	
	public FinalizedPurchasesDTO() {
		
	}
	
	public FinalizedPurchasesDTO(long skuID, Date orderDate, int missedCount) {
		this.skuID = skuID;
		this.orderDate = orderDate;
		this.missedCount = missedCount;
	}
	
	public long getSkuID() {
		return skuID;
	}

	public void setSkuID(long skuID) {
		this.skuID = skuID;
	}	

	public Date getOrderDate() {
		return orderDate;
	}

	public void setOrderDate(Date orderDate) {
		this.orderDate = orderDate;
	}

	public int getMissedCount() {
		return missedCount;
	}

	public void setMissedCount(int missedCount) {
		this.missedCount = missedCount;
	}
}