// Generated with g9.

package edu.iastate.sdmay2025.inbounditems;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.distributioncentersskus.DistributionCentersSkus;
import edu.iastate.sdmay2025.inbounds.Inbounds;
import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;
import edu.iastate.sdmay2025.shoppingcartitems.ShoppingCartItems;

@Entity(name="inbound_items")
public class InboundItems implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    /**
     * The optimistic lock. Available via standard bean get/set operations.
     */
    @Version
    @Column(name="LOCK_FLAG")
    private Integer lockFlag;

    /**
     * Access method for the lockFlag property.
     *
     * @return the current value of the lockFlag property
     */
    public Integer getLockFlag() {
        return lockFlag;
    }

    /**
     * Sets the value of the lockFlag property.
     *
     * @param aLockFlag the new value of the lockFlag property
     */
    public void setLockFlag(Integer aLockFlag) {
        lockFlag = aLockFlag;
    }

    @Id
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(name="expected_units", nullable=false, precision=10)
    private int expectedUnits;
    @Column(name="received_units", nullable=false, precision=10)
    private int receivedUnits;
    @Column(name="damaged_units", nullable=false, precision=10)
    private int damagedUnits;
    @Column(name="expired_units", nullable=false, precision=10)
    private int expiredUnits;
    @Column(name="allocated_units_added", nullable=false, precision=10)
    private int allocatedUnitsAdded;
    @Column(name="on_hand_units_added", nullable=false, precision=10)
    private int onHandUnitsAdded;
    @Column(name="on_hand_total", nullable=false, precision=10)
    private int onHandTotal;
    @Column(nullable=false, length=1)
    private boolean reconciled;
    @Column(name="rejected_units", precision=10)
    private int rejectedUnits;
    @ManyToOne
    @JoinColumn(name="distribution_center_sku_id")
    private DistributionCentersSkus distributionCentersSkus;
    @ManyToOne
    @JoinColumn(name="inbound_id")
    private Inbounds inbounds;
    @ManyToOne
    @JoinColumn(name="original_purchasing_size_id")
    private PurchasingSizes purchasingSizes2;
    @ManyToOne
    @JoinColumn(name="purchasing_size_id")
    private PurchasingSizes purchasingSizes;
    @OneToMany(mappedBy="inboundItems")
    private Set<ShoppingCartItems> shoppingCartItems;

    /** Default constructor. */
    public InboundItems() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for expectedUnits.
     *
     * @return the current value of expectedUnits
     */
    public int getExpectedUnits() {
        return expectedUnits;
    }

    /**
     * Setter method for expectedUnits.
     *
     * @param aExpectedUnits the new value for expectedUnits
     */
    public void setExpectedUnits(int aExpectedUnits) {
        expectedUnits = aExpectedUnits;
    }

    /**
     * Access method for receivedUnits.
     *
     * @return the current value of receivedUnits
     */
    public int getReceivedUnits() {
        return receivedUnits;
    }

    /**
     * Setter method for receivedUnits.
     *
     * @param aReceivedUnits the new value for receivedUnits
     */
    public void setReceivedUnits(int aReceivedUnits) {
        receivedUnits = aReceivedUnits;
    }

    /**
     * Access method for damagedUnits.
     *
     * @return the current value of damagedUnits
     */
    public int getDamagedUnits() {
        return damagedUnits;
    }

    /**
     * Setter method for damagedUnits.
     *
     * @param aDamagedUnits the new value for damagedUnits
     */
    public void setDamagedUnits(int aDamagedUnits) {
        damagedUnits = aDamagedUnits;
    }

    /**
     * Access method for expiredUnits.
     *
     * @return the current value of expiredUnits
     */
    public int getExpiredUnits() {
        return expiredUnits;
    }

    /**
     * Setter method for expiredUnits.
     *
     * @param aExpiredUnits the new value for expiredUnits
     */
    public void setExpiredUnits(int aExpiredUnits) {
        expiredUnits = aExpiredUnits;
    }

    /**
     * Access method for allocatedUnitsAdded.
     *
     * @return the current value of allocatedUnitsAdded
     */
    public int getAllocatedUnitsAdded() {
        return allocatedUnitsAdded;
    }

    /**
     * Setter method for allocatedUnitsAdded.
     *
     * @param aAllocatedUnitsAdded the new value for allocatedUnitsAdded
     */
    public void setAllocatedUnitsAdded(int aAllocatedUnitsAdded) {
        allocatedUnitsAdded = aAllocatedUnitsAdded;
    }

    /**
     * Access method for onHandUnitsAdded.
     *
     * @return the current value of onHandUnitsAdded
     */
    public int getOnHandUnitsAdded() {
        return onHandUnitsAdded;
    }

    /**
     * Setter method for onHandUnitsAdded.
     *
     * @param aOnHandUnitsAdded the new value for onHandUnitsAdded
     */
    public void setOnHandUnitsAdded(int aOnHandUnitsAdded) {
        onHandUnitsAdded = aOnHandUnitsAdded;
    }

    /**
     * Access method for onHandTotal.
     *
     * @return the current value of onHandTotal
     */
    public int getOnHandTotal() {
        return onHandTotal;
    }

    /**
     * Setter method for onHandTotal.
     *
     * @param aOnHandTotal the new value for onHandTotal
     */
    public void setOnHandTotal(int aOnHandTotal) {
        onHandTotal = aOnHandTotal;
    }

    /**
     * Access method for reconciled.
     *
     * @return true if and only if reconciled is currently true
     */
    public boolean getReconciled() {
        return reconciled;
    }

    /**
     * Setter method for reconciled.
     *
     * @param aReconciled the new value for reconciled
     */
    public void setReconciled(boolean aReconciled) {
        reconciled = aReconciled;
    }

    /**
     * Access method for rejectedUnits.
     *
     * @return the current value of rejectedUnits
     */
    public int getRejectedUnits() {
        return rejectedUnits;
    }

    /**
     * Setter method for rejectedUnits.
     *
     * @param aRejectedUnits the new value for rejectedUnits
     */
    public void setRejectedUnits(int aRejectedUnits) {
        rejectedUnits = aRejectedUnits;
    }

    /**
     * Access method for distributionCentersSkus.
     *
     * @return the current value of distributionCentersSkus
     */
    public DistributionCentersSkus getDistributionCentersSkus() {
        return distributionCentersSkus;
    }

    /**
     * Setter method for distributionCentersSkus.
     *
     * @param aDistributionCentersSkus the new value for distributionCentersSkus
     */
    public void setDistributionCentersSkus(DistributionCentersSkus aDistributionCentersSkus) {
        distributionCentersSkus = aDistributionCentersSkus;
    }

    /**
     * Access method for inbounds.
     *
     * @return the current value of inbounds
     */
    public Inbounds getInbounds() {
        return inbounds;
    }

    /**
     * Setter method for inbounds.
     *
     * @param aInbounds the new value for inbounds
     */
    public void setInbounds(Inbounds aInbounds) {
        inbounds = aInbounds;
    }

    /**
     * Access method for purchasingSizes2.
     *
     * @return the current value of purchasingSizes2
     */
    public PurchasingSizes getPurchasingSizes2() {
        return purchasingSizes2;
    }

    /**
     * Setter method for purchasingSizes2.
     *
     * @param aPurchasingSizes2 the new value for purchasingSizes2
     */
    public void setPurchasingSizes2(PurchasingSizes aPurchasingSizes2) {
        purchasingSizes2 = aPurchasingSizes2;
    }

    /**
     * Access method for purchasingSizes.
     *
     * @return the current value of purchasingSizes
     */
    public PurchasingSizes getPurchasingSizes() {
        return purchasingSizes;
    }

    /**
     * Setter method for purchasingSizes.
     *
     * @param aPurchasingSizes the new value for purchasingSizes
     */
    public void setPurchasingSizes(PurchasingSizes aPurchasingSizes) {
        purchasingSizes = aPurchasingSizes;
    }

    /**
     * Access method for shoppingCartItems.
     *
     * @return the current value of shoppingCartItems
     */
    public Set<ShoppingCartItems> getShoppingCartItems() {
        return shoppingCartItems;
    }

    /**
     * Setter method for shoppingCartItems.
     *
     * @param aShoppingCartItems the new value for shoppingCartItems
     */
    public void setShoppingCartItems(Set<ShoppingCartItems> aShoppingCartItems) {
        shoppingCartItems = aShoppingCartItems;
    }

    /**
     * Compares the key for this instance with another InboundItems.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class InboundItems and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof InboundItems)) {
            return false;
        }
        InboundItems that = (InboundItems) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another InboundItems.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof InboundItems)) return false;
        return this.equalKeys(other) && ((InboundItems)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[InboundItems |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
