// Generated with g9.

package edu.iastate.sdmay2025.inbounds;

import java.io.Serializable;
import java.sql.Date;
import java.sql.Timestamp;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.distributors.Distributors;
import edu.iastate.sdmay2025.inbounditems.InboundItems;

@Entity(name="inbounds")
public class Inbounds implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    /**
     * The optimistic lock. Available via standard bean get/set operations.
     */
    @Version
    @Column(name="LOCK_FLAG")
    private Integer lockFlag;

    /**
     * Access method for the lockFlag property.
     *
     * @return the current value of the lockFlag property
     */
    public Integer getLockFlag() {
        return lockFlag;
    }

    /**
     * Sets the value of the lockFlag property.
     *
     * @param aLockFlag the new value of the lockFlag property
     */
    public void setLockFlag(Integer aLockFlag) {
        lockFlag = aLockFlag;
    }

    @Id
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(name="user_id", precision=10)
    private int userId;
    @Column(name="created_at", nullable=false)
    private Timestamp createdAt;
    @Column(name="updated_at", nullable=false)
    private Timestamp updatedAt;
    @Column(name="inbound_date")
    private Date inboundDate;
    @Column(nullable=false, length=1)
    private boolean reconciled;
    @Column(name="invoice_number", nullable=false)
    private String invoiceNumber;
    @Column(name="added_to_bill_dot_com", length=1)
    private boolean addedToBillDotCom;
    @Column(name="inbound_notes", nullable=false)
    private String inboundNotes;
    @Column(name="put_away_submitted", length=1)
    private boolean putAwaySubmitted;
    @Column(length=1)
    private boolean voided;
    @Column(name="voided_at_date")
    private Timestamp voidedAtDate;
    @Column(name="voided_by_id", precision=10)
    private int voidedById;
    @ManyToOne
    @JoinColumn(name="distributor_id")
    private Distributors distributors;
    @OneToMany(mappedBy="inbounds")
    private Set<InboundItems> inboundItems;

    /** Default constructor. */
    public Inbounds() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for userId.
     *
     * @return the current value of userId
     */
    public int getUserId() {
        return userId;
    }

    /**
     * Setter method for userId.
     *
     * @param aUserId the new value for userId
     */
    public void setUserId(int aUserId) {
        userId = aUserId;
    }

    /**
     * Access method for createdAt.
     *
     * @return the current value of createdAt
     */
    public Timestamp getCreatedAt() {
        return createdAt;
    }

    /**
     * Setter method for createdAt.
     *
     * @param aCreatedAt the new value for createdAt
     */
    public void setCreatedAt(Timestamp aCreatedAt) {
        createdAt = aCreatedAt;
    }

    /**
     * Access method for updatedAt.
     *
     * @return the current value of updatedAt
     */
    public Timestamp getUpdatedAt() {
        return updatedAt;
    }

    /**
     * Setter method for updatedAt.
     *
     * @param aUpdatedAt the new value for updatedAt
     */
    public void setUpdatedAt(Timestamp aUpdatedAt) {
        updatedAt = aUpdatedAt;
    }

    /**
     * Access method for inboundDate.
     *
     * @return the current value of inboundDate
     */
    public Date getInboundDate() {
        return inboundDate;
    }

    /**
     * Setter method for inboundDate.
     *
     * @param aInboundDate the new value for inboundDate
     */
    public void setInboundDate(Date aInboundDate) {
        inboundDate = aInboundDate;
    }

    /**
     * Access method for reconciled.
     *
     * @return true if and only if reconciled is currently true
     */
    public boolean getReconciled() {
        return reconciled;
    }

    /**
     * Setter method for reconciled.
     *
     * @param aReconciled the new value for reconciled
     */
    public void setReconciled(boolean aReconciled) {
        reconciled = aReconciled;
    }

    /**
     * Access method for invoiceNumber.
     *
     * @return the current value of invoiceNumber
     */
    public String getInvoiceNumber() {
        return invoiceNumber;
    }

    /**
     * Setter method for invoiceNumber.
     *
     * @param aInvoiceNumber the new value for invoiceNumber
     */
    public void setInvoiceNumber(String aInvoiceNumber) {
        invoiceNumber = aInvoiceNumber;
    }

    /**
     * Access method for addedToBillDotCom.
     *
     * @return true if and only if addedToBillDotCom is currently true
     */
    public boolean getAddedToBillDotCom() {
        return addedToBillDotCom;
    }

    /**
     * Setter method for addedToBillDotCom.
     *
     * @param aAddedToBillDotCom the new value for addedToBillDotCom
     */
    public void setAddedToBillDotCom(boolean aAddedToBillDotCom) {
        addedToBillDotCom = aAddedToBillDotCom;
    }

    /**
     * Access method for inboundNotes.
     *
     * @return the current value of inboundNotes
     */
    public String getInboundNotes() {
        return inboundNotes;
    }

    /**
     * Setter method for inboundNotes.
     *
     * @param aInboundNotes the new value for inboundNotes
     */
    public void setInboundNotes(String aInboundNotes) {
        inboundNotes = aInboundNotes;
    }

    /**
     * Access method for putAwaySubmitted.
     *
     * @return true if and only if putAwaySubmitted is currently true
     */
    public boolean getPutAwaySubmitted() {
        return putAwaySubmitted;
    }

    /**
     * Setter method for putAwaySubmitted.
     *
     * @param aPutAwaySubmitted the new value for putAwaySubmitted
     */
    public void setPutAwaySubmitted(boolean aPutAwaySubmitted) {
        putAwaySubmitted = aPutAwaySubmitted;
    }

    /**
     * Access method for voided.
     *
     * @return true if and only if voided is currently true
     */
    public boolean getVoided() {
        return voided;
    }

    /**
     * Setter method for voided.
     *
     * @param aVoided the new value for voided
     */
    public void setVoided(boolean aVoided) {
        voided = aVoided;
    }

    /**
     * Access method for voidedAtDate.
     *
     * @return the current value of voidedAtDate
     */
    public Timestamp getVoidedAtDate() {
        return voidedAtDate;
    }

    /**
     * Setter method for voidedAtDate.
     *
     * @param aVoidedAtDate the new value for voidedAtDate
     */
    public void setVoidedAtDate(Timestamp aVoidedAtDate) {
        voidedAtDate = aVoidedAtDate;
    }

    /**
     * Access method for voidedById.
     *
     * @return the current value of voidedById
     */
    public int getVoidedById() {
        return voidedById;
    }

    /**
     * Setter method for voidedById.
     *
     * @param aVoidedById the new value for voidedById
     */
    public void setVoidedById(int aVoidedById) {
        voidedById = aVoidedById;
    }

    /**
     * Access method for distributors.
     *
     * @return the current value of distributors
     */
    public Distributors getDistributors() {
        return distributors;
    }

    /**
     * Setter method for distributors.
     *
     * @param aDistributors the new value for distributors
     */
    public void setDistributors(Distributors aDistributors) {
        distributors = aDistributors;
    }

    /**
     * Access method for inboundItems.
     *
     * @return the current value of inboundItems
     */
    public Set<InboundItems> getInboundItems() {
        return inboundItems;
    }

    /**
     * Setter method for inboundItems.
     *
     * @param aInboundItems the new value for inboundItems
     */
    public void setInboundItems(Set<InboundItems> aInboundItems) {
        inboundItems = aInboundItems;
    }

    /**
     * Compares the key for this instance with another Inbounds.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class Inbounds and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof Inbounds)) {
            return false;
        }
        Inbounds that = (Inbounds) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another Inbounds.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof Inbounds)) return false;
        return this.equalKeys(other) && ((Inbounds)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[Inbounds |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
