// Generated with g9.

package edu.iastate.sdmay2025.inventorysnapshots;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Version;

import edu.iastate.sdmay2025.distributioncentersskus.DistributionCentersSkus;
import edu.iastate.sdmay2025.financialrecords.FinancialRecords;
import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;

@Entity(name="inventory_snapshots")
public class InventorySnapshots implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(nullable=false, precision=10)
    private int count;
    @Column(name="total_cost", nullable=false, precision=131089)
    private BigDecimal totalCost;
    @ManyToOne
    @JoinColumn(name="financial_record_id")
    private FinancialRecords financialRecords;
    @ManyToOne
    @JoinColumn(name="purchasing_size_id")
    private PurchasingSizes purchasingSizes;
    @ManyToOne
    @JoinColumn(name="distribution_center_sku_id")
    private DistributionCentersSkus distributionCentersSkus;

    /** Default constructor. */
    public InventorySnapshots() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for count.
     *
     * @return the current value of count
     */
    public int getCount() {
        return count;
    }

    /**
     * Setter method for count.
     *
     * @param aCount the new value for count
     */
    public void setCount(int aCount) {
        count = aCount;
    }

    /**
     * Access method for totalCost.
     *
     * @return the current value of totalCost
     */
    public BigDecimal getTotalCost() {
        return totalCost;
    }

    /**
     * Setter method for totalCost.
     *
     * @param aTotalCost the new value for totalCost
     */
    public void setTotalCost(BigDecimal aTotalCost) {
        totalCost = aTotalCost;
    }

    /**
     * Access method for financialRecords.
     *
     * @return the current value of financialRecords
     */
    public FinancialRecords getFinancialRecords() {
        return financialRecords;
    }

    /**
     * Setter method for financialRecords.
     *
     * @param aFinancialRecords the new value for financialRecords
     */
    public void setFinancialRecords(FinancialRecords aFinancialRecords) {
        financialRecords = aFinancialRecords;
    }

    /**
     * Access method for purchasingSizes.
     *
     * @return the current value of purchasingSizes
     */
    public PurchasingSizes getPurchasingSizes() {
        return purchasingSizes;
    }

    /**
     * Setter method for purchasingSizes.
     *
     * @param aPurchasingSizes the new value for purchasingSizes
     */
    public void setPurchasingSizes(PurchasingSizes aPurchasingSizes) {
        purchasingSizes = aPurchasingSizes;
    }

    /**
     * Access method for distributionCentersSkus.
     *
     * @return the current value of distributionCentersSkus
     */
    public DistributionCentersSkus getDistributionCentersSkus() {
        return distributionCentersSkus;
    }

    /**
     * Setter method for distributionCentersSkus.
     *
     * @param aDistributionCentersSkus the new value for distributionCentersSkus
     */
    public void setDistributionCentersSkus(DistributionCentersSkus aDistributionCentersSkus) {
        distributionCentersSkus = aDistributionCentersSkus;
    }

    /**
     * Compares the key for this instance with another InventorySnapshots.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class InventorySnapshots and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof InventorySnapshots)) {
            return false;
        }
        InventorySnapshots that = (InventorySnapshots) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another InventorySnapshots.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof InventorySnapshots)) return false;
        return this.equalKeys(other) && ((InventorySnapshots)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[InventorySnapshots |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
