package edu.iastate.sdmay2025.inventorysnapshots;

import java.util.Collection;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * REST Api Controller for the Inventory Snapshots
 * 
 * @author Sam Stifter, Andrew Smith
 */
@RestController
@CrossOrigin(origins= {"*"})
public class InventorySnapshotsController {
		
	@Autowired
	InventorySnapshotsRepo inventorySnapshotsRepo;
	
	@ResponseBody
	@RequestMapping(method = RequestMethod.GET, path="/sku_hist/{sku}")
	public List<InventorySnapshotsDto> getSkuHistory(@PathVariable long sku) {
		List<InventorySnapshotsDto> result = inventorySnapshotsRepo.getSkuInventorySnapshots(sku);
		return result;
	}

}
