// Generated with g9.

package edu.iastate.sdmay2025.misseditems;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Version;

import edu.iastate.sdmay2025.finalizedpurchases.FinalizedPurchases;
import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;

@Entity(name="missed_items")
public class MissedItems implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(nullable=false, precision=10)
    private int count;
    @Column(name="created_at")
    private Timestamp createdAt;
    @Column(name="updated_at")
    private Timestamp updatedAt;
    @Column(name="source_type", nullable=false, precision=10)
    private int sourceType;
    @Column(length=1)
    private boolean resolved;
    @ManyToOne
    @JoinColumn(name="purchasing_size_id")
    private PurchasingSizes purchasingSizes;
    @ManyToOne
    @JoinColumn(name="finalized_purchase_id")
    private FinalizedPurchases finalizedPurchases;

    /** Default constructor. */
    public MissedItems() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for count.
     *
     * @return the current value of count
     */
    public int getCount() {
        return count;
    }

    /**
     * Setter method for count.
     *
     * @param aCount the new value for count
     */
    public void setCount(int aCount) {
        count = aCount;
    }

    /**
     * Access method for createdAt.
     *
     * @return the current value of createdAt
     */
    public Timestamp getCreatedAt() {
        return createdAt;
    }

    /**
     * Setter method for createdAt.
     *
     * @param aCreatedAt the new value for createdAt
     */
    public void setCreatedAt(Timestamp aCreatedAt) {
        createdAt = aCreatedAt;
    }

    /**
     * Access method for updatedAt.
     *
     * @return the current value of updatedAt
     */
    public Timestamp getUpdatedAt() {
        return updatedAt;
    }

    /**
     * Setter method for updatedAt.
     *
     * @param aUpdatedAt the new value for updatedAt
     */
    public void setUpdatedAt(Timestamp aUpdatedAt) {
        updatedAt = aUpdatedAt;
    }

    /**
     * Access method for sourceType.
     *
     * @return the current value of sourceType
     */
    public int getSourceType() {
        return sourceType;
    }

    /**
     * Setter method for sourceType.
     *
     * @param aSourceType the new value for sourceType
     */
    public void setSourceType(int aSourceType) {
        sourceType = aSourceType;
    }

    /**
     * Access method for resolved.
     *
     * @return true if and only if resolved is currently true
     */
    public boolean isResolved() {
        return resolved;
    }

    /**
     * Setter method for resolved.
     *
     * @param aResolved the new value for resolved
     */
    public void setResolved(boolean aResolved) {
        resolved = aResolved;
    }

    /**
     * Access method for purchasingSizes.
     *
     * @return the current value of purchasingSizes
     */
    public PurchasingSizes getPurchasingSizes() {
        return purchasingSizes;
    }

    /**
     * Setter method for purchasingSizes.
     *
     * @param aPurchasingSizes the new value for purchasingSizes
     */
    public void setPurchasingSizes(PurchasingSizes aPurchasingSizes) {
        purchasingSizes = aPurchasingSizes;
    }

    /**
     * Access method for finalizedPurchases.
     *
     * @return the current value of finalizedPurchases
     */
    public FinalizedPurchases getFinalizedPurchases() {
        return finalizedPurchases;
    }

    /**
     * Setter method for finalizedPurchases.
     *
     * @param aFinalizedPurchases the new value for finalizedPurchases
     */
    public void setFinalizedPurchases(FinalizedPurchases aFinalizedPurchases) {
        finalizedPurchases = aFinalizedPurchases;
    }

    /**
     * Compares the key for this instance with another MissedItems.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class MissedItems and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof MissedItems)) {
            return false;
        }
        MissedItems that = (MissedItems) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another MissedItems.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof MissedItems)) return false;
        return this.equalKeys(other) && ((MissedItems)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[MissedItems |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
