package edu.iastate.sdmay2025.predictions;

import java.sql.Timestamp;

/**
 * Prediction storage object for receiving predictions
 * 
 * @author Sam Stifter
 *
 */
public class PredictionDTO {
	
	private Integer id;
	private long sku_id;
	private int qty_to_order;
	private Timestamp date;
	
	public PredictionDTO() {
		
	}
	
	public PredictionDTO(Predictions prediction) {
		if(prediction != null) {
			id = prediction.getId();
			if(prediction.getSkus() != null) sku_id = prediction.getSkus().getId();
			qty_to_order = prediction.getQtyToOrder();
			date = prediction.getDate();
		}
	}
	
	//@author Andrew Smith
	public PredictionDTO(Integer id, long sku_id, int qty_to_order, Timestamp date) {
		this.id = id;
		this.sku_id = sku_id;
		this.qty_to_order = qty_to_order;
		this.date = date;
	}
	
	public Integer getId() {
		return id;
	}
	public void setId(Integer id) {
		this.id = id;
	}
	public long getSku_id() {
		return sku_id;
	}
	public void setSku_id(long sku_id) {
		this.sku_id = sku_id;
	}
	public int getQty_to_order() {
		return qty_to_order;
	}
	public void setQty_to_order(int qty_to_order) {
		this.qty_to_order = qty_to_order;
	}
	public Timestamp getDate() {
		return date;
	}
	public void setDate(Timestamp date) {
		this.date = date;
	}
	
	

}
