// Generated with g9.

package edu.iastate.sdmay2025.products;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.breweries.Breweries;
import edu.iastate.sdmay2025.skus.Skus;
import edu.iastate.sdmay2025.subcategories.Subcategories;

@Entity(name="products")
public class Products implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    private String name;
    @Column(length=1)
    private boolean deleted;
    @ManyToOne
    @JoinColumn(name="subcategory_id")
    private Subcategories subcategories;
    @ManyToOne
    @JoinColumn(name="brewery_id")
    private Breweries breweries;
    @OneToMany(mappedBy="products")
    private Set<Skus> skus;

    /** Default constructor. */
    public Products() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for name.
     *
     * @return the current value of name
     */
    public String getName() {
        return name;
    }

    /**
     * Setter method for name.
     *
     * @param aName the new value for name
     */
    public void setName(String aName) {
        name = aName;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for subcategories.
     *
     * @return the current value of subcategories
     */
    public Subcategories getSubcategories() {
        return subcategories;
    }

    /**
     * Setter method for subcategories.
     *
     * @param aSubcategories the new value for subcategories
     */
    public void setSubcategories(Subcategories aSubcategories) {
        subcategories = aSubcategories;
    }

    /**
     * Access method for breweries.
     *
     * @return the current value of breweries
     */
    public Breweries getBreweries() {
        return breweries;
    }

    /**
     * Setter method for breweries.
     *
     * @param aBreweries the new value for breweries
     */
    public void setBreweries(Breweries aBreweries) {
        breweries = aBreweries;
    }

    /**
     * Access method for skus.
     *
     * @return the current value of skus
     */
    public Set<Skus> getSkus() {
        return skus;
    }

    /**
     * Setter method for skus.
     *
     * @param aSkus the new value for skus
     */
    public void setSkus(Set<Skus> aSkus) {
        skus = aSkus;
    }

    /**
     * Compares the key for this instance with another Products.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class Products and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof Products)) {
            return false;
        }
        Products that = (Products) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another Products.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof Products)) return false;
        return this.equalKeys(other) && ((Products)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[Products |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
