// Generated with g9.

package edu.iastate.sdmay2025.productsizes;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;
import edu.iastate.sdmay2025.skus.Skus;

@Entity(name="product_sizes")
public class ProductSizes implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    private String name;
    @Column(length=1)
    private boolean deleted;
    @Column(name="deliverable_item", length=1)
    private boolean deliverableItem;
    @Column(name="unit_of_measurement", nullable=false)
    private String unitOfMeasurement;
    @Column(name="size_of_measurement", precision=131089)
    private BigDecimal sizeOfMeasurement;
    @Column(precision=131089)
    private BigDecimal units;
    @Column(name="pack_name", nullable=false)
    private String packName;
    @Column(name="number_of_packs", precision=131089)
    private BigDecimal numberOfPacks;
    @Column(name="pickable_item", length=1)
    private boolean pickableItem;
    @OneToMany(mappedBy="productSizes")
    private Set<Skus> skus;
    @OneToMany(mappedBy="productSizes")
    private Set<PurchasingSizes> purchasingSizes;

    /** Default constructor. */
    public ProductSizes() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for name.
     *
     * @return the current value of name
     */
    public String getName() {
        return name;
    }

    /**
     * Setter method for name.
     *
     * @param aName the new value for name
     */
    public void setName(String aName) {
        name = aName;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for deliverableItem.
     *
     * @return true if and only if deliverableItem is currently true
     */
    public boolean isDeliverableItem() {
        return deliverableItem;
    }

    /**
     * Setter method for deliverableItem.
     *
     * @param aDeliverableItem the new value for deliverableItem
     */
    public void setDeliverableItem(boolean aDeliverableItem) {
        deliverableItem = aDeliverableItem;
    }

    /**
     * Access method for unitOfMeasurement.
     *
     * @return the current value of unitOfMeasurement
     */
    public String getUnitOfMeasurement() {
        return unitOfMeasurement;
    }

    /**
     * Setter method for unitOfMeasurement.
     *
     * @param aUnitOfMeasurement the new value for unitOfMeasurement
     */
    public void setUnitOfMeasurement(String aUnitOfMeasurement) {
        unitOfMeasurement = aUnitOfMeasurement;
    }

    /**
     * Access method for sizeOfMeasurement.
     *
     * @return the current value of sizeOfMeasurement
     */
    public BigDecimal getSizeOfMeasurement() {
        return sizeOfMeasurement;
    }

    /**
     * Setter method for sizeOfMeasurement.
     *
     * @param aSizeOfMeasurement the new value for sizeOfMeasurement
     */
    public void setSizeOfMeasurement(BigDecimal aSizeOfMeasurement) {
        sizeOfMeasurement = aSizeOfMeasurement;
    }

    /**
     * Access method for units.
     *
     * @return the current value of units
     */
    public BigDecimal getUnits() {
        return units;
    }

    /**
     * Setter method for units.
     *
     * @param aUnits the new value for units
     */
    public void setUnits(BigDecimal aUnits) {
        units = aUnits;
    }

    /**
     * Access method for packName.
     *
     * @return the current value of packName
     */
    public String getPackName() {
        return packName;
    }

    /**
     * Setter method for packName.
     *
     * @param aPackName the new value for packName
     */
    public void setPackName(String aPackName) {
        packName = aPackName;
    }

    /**
     * Access method for numberOfPacks.
     *
     * @return the current value of numberOfPacks
     */
    public BigDecimal getNumberOfPacks() {
        return numberOfPacks;
    }

    /**
     * Setter method for numberOfPacks.
     *
     * @param aNumberOfPacks the new value for numberOfPacks
     */
    public void setNumberOfPacks(BigDecimal aNumberOfPacks) {
        numberOfPacks = aNumberOfPacks;
    }

    /**
     * Access method for pickableItem.
     *
     * @return true if and only if pickableItem is currently true
     */
    public boolean isPickableItem() {
        return pickableItem;
    }

    /**
     * Setter method for pickableItem.
     *
     * @param aPickableItem the new value for pickableItem
     */
    public void setPickableItem(boolean aPickableItem) {
        pickableItem = aPickableItem;
    }

    /**
     * Access method for skus.
     *
     * @return the current value of skus
     */
    public Set<Skus> getSkus() {
        return skus;
    }

    /**
     * Setter method for skus.
     *
     * @param aSkus the new value for skus
     */
    public void setSkus(Set<Skus> aSkus) {
        skus = aSkus;
    }

    /**
     * Access method for purchasingSizes.
     *
     * @return the current value of purchasingSizes
     */
    public Set<PurchasingSizes> getPurchasingSizes() {
        return purchasingSizes;
    }

    /**
     * Setter method for purchasingSizes.
     *
     * @param aPurchasingSizes the new value for purchasingSizes
     */
    public void setPurchasingSizes(Set<PurchasingSizes> aPurchasingSizes) {
        purchasingSizes = aPurchasingSizes;
    }

    /**
     * Compares the key for this instance with another ProductSizes.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class ProductSizes and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof ProductSizes)) {
            return false;
        }
        ProductSizes that = (ProductSizes) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another ProductSizes.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof ProductSizes)) return false;
        return this.equalKeys(other) && ((ProductSizes)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[ProductSizes |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
