// Generated with g9.

package edu.iastate.sdmay2025.purchasingsizes;

import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.distributors.Distributors;
import edu.iastate.sdmay2025.inventorysnapshots.InventorySnapshots;
import edu.iastate.sdmay2025.misseditems.MissedItems;
import edu.iastate.sdmay2025.originalpurchasingsizegroups.OriginalPurchasingSizeGroups;
import edu.iastate.sdmay2025.productsizes.ProductSizes;
import edu.iastate.sdmay2025.shoppingcartitems.ShoppingCartItems;
import edu.iastate.sdmay2025.skus.Skus;

@Entity(name="purchasing_sizes")
public class PurchasingSizes implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(length=1)
    private boolean deleted;
    @Column(length=1)
    private boolean available;
    @Column(name="available_units", nullable=false, precision=131089)
    private BigDecimal availableUnits;
    @Column(name="cost_of_goods", precision=131089)
    private BigDecimal costOfGoods;
    @Column(name="auto_reorder", length=1)
    private boolean autoReorder;
    @Column(name="on_hand_inventory_minimum", nullable=false, precision=131089)
    private BigDecimal onHandInventoryMinimum;
    @Column(name="reorder_batch_size", nullable=false, precision=131089)
    private BigDecimal reorderBatchSize;
    @Column(name="on_hand_inventory_target_level", nullable=false, precision=131089)
    private BigDecimal onHandInventoryTargetLevel;
    @Column(name="on_hand_inventory", nullable=false, precision=131089)
    private BigDecimal onHandInventory;
    @Column(name="last_inventory_count", nullable=false, precision=131089)
    private BigDecimal lastInventoryCount;
    @Column(name="last_inventory_count_date")
    private Timestamp lastInventoryCountDate;
    @Column(name="on_hand_count_divisor", nullable=false, precision=131089)
    private BigDecimal onHandCountDivisor;
    @Column(name="unlimited_distributor_inventory", nullable=false, length=1)
    private boolean unlimitedDistributorInventory;
    @Column(length=1)
    private boolean archived;
    @OneToMany(mappedBy="purchasingSizes")
    private Set<ShoppingCartItems> shoppingCartItems;
    @ManyToOne
    @JoinColumn(name="distributor_id")
    private Distributors distributors;
    @ManyToOne
    @JoinColumn(name="product_size_id")
    private ProductSizes productSizes;
    @OneToMany(mappedBy="purchasingSizes2")
    private Set<PurchasingSizes> purchasingSizes3;
    @ManyToOne
    @JoinColumn(name="reorder_purchasing_size_id")
    private PurchasingSizes purchasingSizes2;
    @ManyToOne
    @JoinColumn(name="sku_id")
    private Skus skus;
    @OneToMany(mappedBy="purchasingSizes")
    private Set<OriginalPurchasingSizeGroups> originalPurchasingSizeGroups;
    @OneToMany(mappedBy="purchasingSizes")
    private Set<InventorySnapshots> inventorySnapshots;
    @OneToMany(mappedBy="purchasingSizes4")
    private Set<PurchasingSizes> purchasingSizes5;
    @ManyToOne
    @JoinColumn(name="base_sku_id")
    private PurchasingSizes purchasingSizes4;
    @OneToMany(mappedBy="purchasingSizes")
    private Set<MissedItems> missedItems;

    /** Default constructor. */
    public PurchasingSizes() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for available.
     *
     * @return true if and only if available is currently true
     */
    public boolean isAvailable() {
        return available;
    }

    /**
     * Setter method for available.
     *
     * @param aAvailable the new value for available
     */
    public void setAvailable(boolean aAvailable) {
        available = aAvailable;
    }

    /**
     * Access method for availableUnits.
     *
     * @return the current value of availableUnits
     */
    public BigDecimal getAvailableUnits() {
        return availableUnits;
    }

    /**
     * Setter method for availableUnits.
     *
     * @param aAvailableUnits the new value for availableUnits
     */
    public void setAvailableUnits(BigDecimal aAvailableUnits) {
        availableUnits = aAvailableUnits;
    }

    /**
     * Access method for costOfGoods.
     *
     * @return the current value of costOfGoods
     */
    public BigDecimal getCostOfGoods() {
        return costOfGoods;
    }

    /**
     * Setter method for costOfGoods.
     *
     * @param aCostOfGoods the new value for costOfGoods
     */
    public void setCostOfGoods(BigDecimal aCostOfGoods) {
        costOfGoods = aCostOfGoods;
    }

    /**
     * Access method for autoReorder.
     *
     * @return true if and only if autoReorder is currently true
     */
    public boolean isAutoReorder() {
        return autoReorder;
    }

    /**
     * Setter method for autoReorder.
     *
     * @param aAutoReorder the new value for autoReorder
     */
    public void setAutoReorder(boolean aAutoReorder) {
        autoReorder = aAutoReorder;
    }

    /**
     * Access method for onHandInventoryMinimum.
     *
     * @return the current value of onHandInventoryMinimum
     */
    public BigDecimal getOnHandInventoryMinimum() {
        return onHandInventoryMinimum;
    }

    /**
     * Setter method for onHandInventoryMinimum.
     *
     * @param aOnHandInventoryMinimum the new value for onHandInventoryMinimum
     */
    public void setOnHandInventoryMinimum(BigDecimal aOnHandInventoryMinimum) {
        onHandInventoryMinimum = aOnHandInventoryMinimum;
    }

    /**
     * Access method for reorderBatchSize.
     *
     * @return the current value of reorderBatchSize
     */
    public BigDecimal getReorderBatchSize() {
        return reorderBatchSize;
    }

    /**
     * Setter method for reorderBatchSize.
     *
     * @param aReorderBatchSize the new value for reorderBatchSize
     */
    public void setReorderBatchSize(BigDecimal aReorderBatchSize) {
        reorderBatchSize = aReorderBatchSize;
    }

    /**
     * Access method for onHandInventoryTargetLevel.
     *
     * @return the current value of onHandInventoryTargetLevel
     */
    public BigDecimal getOnHandInventoryTargetLevel() {
        return onHandInventoryTargetLevel;
    }

    /**
     * Setter method for onHandInventoryTargetLevel.
     *
     * @param aOnHandInventoryTargetLevel the new value for onHandInventoryTargetLevel
     */
    public void setOnHandInventoryTargetLevel(BigDecimal aOnHandInventoryTargetLevel) {
        onHandInventoryTargetLevel = aOnHandInventoryTargetLevel;
    }

    /**
     * Access method for onHandInventory.
     *
     * @return the current value of onHandInventory
     */
    public BigDecimal getOnHandInventory() {
        return onHandInventory;
    }

    /**
     * Setter method for onHandInventory.
     *
     * @param aOnHandInventory the new value for onHandInventory
     */
    public void setOnHandInventory(BigDecimal aOnHandInventory) {
        onHandInventory = aOnHandInventory;
    }

    /**
     * Access method for lastInventoryCount.
     *
     * @return the current value of lastInventoryCount
     */
    public BigDecimal getLastInventoryCount() {
        return lastInventoryCount;
    }

    /**
     * Setter method for lastInventoryCount.
     *
     * @param aLastInventoryCount the new value for lastInventoryCount
     */
    public void setLastInventoryCount(BigDecimal aLastInventoryCount) {
        lastInventoryCount = aLastInventoryCount;
    }

    /**
     * Access method for lastInventoryCountDate.
     *
     * @return the current value of lastInventoryCountDate
     */
    public Timestamp getLastInventoryCountDate() {
        return lastInventoryCountDate;
    }

    /**
     * Setter method for lastInventoryCountDate.
     *
     * @param aLastInventoryCountDate the new value for lastInventoryCountDate
     */
    public void setLastInventoryCountDate(Timestamp aLastInventoryCountDate) {
        lastInventoryCountDate = aLastInventoryCountDate;
    }

    /**
     * Access method for onHandCountDivisor.
     *
     * @return the current value of onHandCountDivisor
     */
    public BigDecimal getOnHandCountDivisor() {
        return onHandCountDivisor;
    }

    /**
     * Setter method for onHandCountDivisor.
     *
     * @param aOnHandCountDivisor the new value for onHandCountDivisor
     */
    public void setOnHandCountDivisor(BigDecimal aOnHandCountDivisor) {
        onHandCountDivisor = aOnHandCountDivisor;
    }

    /**
     * Access method for unlimitedDistributorInventory.
     *
     * @return true if and only if unlimitedDistributorInventory is currently true
     */
    public boolean isUnlimitedDistributorInventory() {
        return unlimitedDistributorInventory;
    }

    /**
     * Setter method for unlimitedDistributorInventory.
     *
     * @param aUnlimitedDistributorInventory the new value for unlimitedDistributorInventory
     */
    public void setUnlimitedDistributorInventory(boolean aUnlimitedDistributorInventory) {
        unlimitedDistributorInventory = aUnlimitedDistributorInventory;
    }

    /**
     * Access method for archived.
     *
     * @return true if and only if archived is currently true
     */
    public boolean isArchived() {
        return archived;
    }

    /**
     * Setter method for archived.
     *
     * @param aArchived the new value for archived
     */
    public void setArchived(boolean aArchived) {
        archived = aArchived;
    }

    /**
     * Access method for shoppingCartItems.
     *
     * @return the current value of shoppingCartItems
     */
    public Set<ShoppingCartItems> getShoppingCartItems() {
        return shoppingCartItems;
    }

    /**
     * Setter method for shoppingCartItems.
     *
     * @param aShoppingCartItems the new value for shoppingCartItems
     */
    public void setShoppingCartItems(Set<ShoppingCartItems> aShoppingCartItems) {
        shoppingCartItems = aShoppingCartItems;
    }

    /**
     * Access method for distributors.
     *
     * @return the current value of distributors
     */
    public Distributors getDistributors() {
        return distributors;
    }

    /**
     * Setter method for distributors.
     *
     * @param aDistributors the new value for distributors
     */
    public void setDistributors(Distributors aDistributors) {
        distributors = aDistributors;
    }

    /**
     * Access method for productSizes.
     *
     * @return the current value of productSizes
     */
    public ProductSizes getProductSizes() {
        return productSizes;
    }

    /**
     * Setter method for productSizes.
     *
     * @param aProductSizes the new value for productSizes
     */
    public void setProductSizes(ProductSizes aProductSizes) {
        productSizes = aProductSizes;
    }

    /**
     * Access method for purchasingSizes3.
     *
     * @return the current value of purchasingSizes3
     */
    public Set<PurchasingSizes> getPurchasingSizes3() {
        return purchasingSizes3;
    }

    /**
     * Setter method for purchasingSizes3.
     *
     * @param aPurchasingSizes3 the new value for purchasingSizes3
     */
    public void setPurchasingSizes3(Set<PurchasingSizes> aPurchasingSizes3) {
        purchasingSizes3 = aPurchasingSizes3;
    }

    /**
     * Access method for purchasingSizes2.
     *
     * @return the current value of purchasingSizes2
     */
    public PurchasingSizes getPurchasingSizes2() {
        return purchasingSizes2;
    }

    /**
     * Setter method for purchasingSizes2.
     *
     * @param aPurchasingSizes2 the new value for purchasingSizes2
     */
    public void setPurchasingSizes2(PurchasingSizes aPurchasingSizes2) {
        purchasingSizes2 = aPurchasingSizes2;
    }

    /**
     * Access method for skus.
     *
     * @return the current value of skus
     */
    public Skus getSkus() {
        return skus;
    }

    /**
     * Setter method for skus.
     *
     * @param aSkus the new value for skus
     */
    public void setSkus(Skus aSkus) {
        skus = aSkus;
    }

    /**
     * Access method for originalPurchasingSizeGroups.
     *
     * @return the current value of originalPurchasingSizeGroups
     */
    public Set<OriginalPurchasingSizeGroups> getOriginalPurchasingSizeGroups() {
        return originalPurchasingSizeGroups;
    }

    /**
     * Setter method for originalPurchasingSizeGroups.
     *
     * @param aOriginalPurchasingSizeGroups the new value for originalPurchasingSizeGroups
     */
    public void setOriginalPurchasingSizeGroups(Set<OriginalPurchasingSizeGroups> aOriginalPurchasingSizeGroups) {
        originalPurchasingSizeGroups = aOriginalPurchasingSizeGroups;
    }

    /**
     * Access method for inventorySnapshots.
     *
     * @return the current value of inventorySnapshots
     */
    public Set<InventorySnapshots> getInventorySnapshots() {
        return inventorySnapshots;
    }

    /**
     * Setter method for inventorySnapshots.
     *
     * @param aInventorySnapshots the new value for inventorySnapshots
     */
    public void setInventorySnapshots(Set<InventorySnapshots> aInventorySnapshots) {
        inventorySnapshots = aInventorySnapshots;
    }

    /**
     * Access method for purchasingSizes5.
     *
     * @return the current value of purchasingSizes5
     */
    public Set<PurchasingSizes> getPurchasingSizes5() {
        return purchasingSizes5;
    }

    /**
     * Setter method for purchasingSizes5.
     *
     * @param aPurchasingSizes5 the new value for purchasingSizes5
     */
    public void setPurchasingSizes5(Set<PurchasingSizes> aPurchasingSizes5) {
        purchasingSizes5 = aPurchasingSizes5;
    }

    /**
     * Access method for purchasingSizes4.
     *
     * @return the current value of purchasingSizes4
     */
    public PurchasingSizes getPurchasingSizes4() {
        return purchasingSizes4;
    }

    /**
     * Setter method for purchasingSizes4.
     *
     * @param aPurchasingSizes4 the new value for purchasingSizes4
     */
    public void setPurchasingSizes4(PurchasingSizes aPurchasingSizes4) {
        purchasingSizes4 = aPurchasingSizes4;
    }

    /**
     * Access method for missedItems.
     *
     * @return the current value of missedItems
     */
    public Set<MissedItems> getMissedItems() {
        return missedItems;
    }

    /**
     * Setter method for missedItems.
     *
     * @param aMissedItems the new value for missedItems
     */
    public void setMissedItems(Set<MissedItems> aMissedItems) {
        missedItems = aMissedItems;
    }

    /**
     * Compares the key for this instance with another PurchasingSizes.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class PurchasingSizes and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof PurchasingSizes)) {
            return false;
        }
        PurchasingSizes that = (PurchasingSizes) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another PurchasingSizes.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof PurchasingSizes)) return false;
        return this.equalKeys(other) && ((PurchasingSizes)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[PurchasingSizes |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
