// Generated with g9.

package edu.iastate.sdmay2025.shoppingcartitems;

import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Version;

import edu.iastate.sdmay2025.corporateusers.CorporateUsers;
import edu.iastate.sdmay2025.distributioncentersskus.DistributionCentersSkus;
import edu.iastate.sdmay2025.finalizedpurchases.FinalizedPurchases;
import edu.iastate.sdmay2025.inbounditems.InboundItems;
import edu.iastate.sdmay2025.originalpurchasingsizegroups.OriginalPurchasingSizeGroups;
import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;
import edu.iastate.sdmay2025.removalreasons.RemovalReasons;

@Entity(name="shopping_cart_items")
public class ShoppingCartItems implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    /**
     * The optimistic lock. Available via standard bean get/set operations.
     */
    @Version
    @Column(name="LOCK_FLAG")
    private Integer lockFlag;

    /**
     * Access method for the lockFlag property.
     *
     * @return the current value of the lockFlag property
     */
    public Integer getLockFlag() {
        return lockFlag;
    }

    /**
     * Sets the value of the lockFlag property.
     *
     * @param aLockFlag the new value of the lockFlag property
     */
    public void setLockFlag(Integer aLockFlag) {
        lockFlag = aLockFlag;
    }

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=10)
    private int id;
    @Column(name="created_at", nullable=false)
    private Timestamp createdAt;
    @Column(name="updated_at", nullable=false)
    private Timestamp updatedAt;
    @Column(name="removed_from_cart", length=1)
    private boolean removedFromCart;
    @Column(name="purchase_finalized", length=1)
    private boolean purchaseFinalized;
    @Column(name="cost_of_goods", precision=131089)
    private BigDecimal costOfGoods;
    @Column(name="on_hand", length=1)
    private boolean onHand;
    @Column(name="item_status", precision=10)
    private int itemStatus;
    @ManyToOne
    @JoinColumn(name="original_purchasing_size_group_id")
    private OriginalPurchasingSizeGroups originalPurchasingSizeGroups;
    @ManyToOne
    @JoinColumn(name="removal_reason_id")
    private RemovalReasons removalReasons;
    @ManyToOne
    @JoinColumn(name="procured_purchasing_size_id")
    private PurchasingSizes purchasingSizes;
    @ManyToOne
    @JoinColumn(name="corporate_user_id")
    private CorporateUsers corporateUsers;
    @ManyToOne
    @JoinColumn(name="finalized_purchase_id")
    private FinalizedPurchases finalizedPurchases;
    @ManyToOne
    @JoinColumn(name="on_hand_finalized_purchase_id")
    private FinalizedPurchases finalizedPurchases2;
    @ManyToOne
    @JoinColumn(name="distribution_center_sku_id")
    private DistributionCentersSkus distributionCentersSkus;
    @ManyToOne
    @JoinColumn(name="inbound_item_id")
    private InboundItems inboundItems;

    /** Default constructor. */
    public ShoppingCartItems() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public int getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(int aId) {
        id = aId;
    }

    /**
     * Access method for createdAt.
     *
     * @return the current value of createdAt
     */
    public Timestamp getCreatedAt() {
        return createdAt;
    }

    /**
     * Setter method for createdAt.
     *
     * @param aCreatedAt the new value for createdAt
     */
    public void setCreatedAt(Timestamp aCreatedAt) {
        createdAt = aCreatedAt;
    }

    /**
     * Access method for updatedAt.
     *
     * @return the current value of updatedAt
     */
    public Timestamp getUpdatedAt() {
        return updatedAt;
    }

    /**
     * Setter method for updatedAt.
     *
     * @param aUpdatedAt the new value for updatedAt
     */
    public void setUpdatedAt(Timestamp aUpdatedAt) {
        updatedAt = aUpdatedAt;
    }

    /**
     * Access method for removedFromCart.
     *
     * @return true if and only if removedFromCart is currently true
     */
    public boolean isRemovedFromCart() {
        return removedFromCart;
    }

    /**
     * Setter method for removedFromCart.
     *
     * @param aRemovedFromCart the new value for removedFromCart
     */
    public void setRemovedFromCart(boolean aRemovedFromCart) {
        removedFromCart = aRemovedFromCart;
    }

    /**
     * Access method for purchaseFinalized.
     *
     * @return true if and only if purchaseFinalized is currently true
     */
    public boolean isPurchaseFinalized() {
        return purchaseFinalized;
    }

    /**
     * Setter method for purchaseFinalized.
     *
     * @param aPurchaseFinalized the new value for purchaseFinalized
     */
    public void setPurchaseFinalized(boolean aPurchaseFinalized) {
        purchaseFinalized = aPurchaseFinalized;
    }

    /**
     * Access method for costOfGoods.
     *
     * @return the current value of costOfGoods
     */
    public BigDecimal getCostOfGoods() {
        return costOfGoods;
    }

    /**
     * Setter method for costOfGoods.
     *
     * @param aCostOfGoods the new value for costOfGoods
     */
    public void setCostOfGoods(BigDecimal aCostOfGoods) {
        costOfGoods = aCostOfGoods;
    }

    /**
     * Access method for onHand.
     *
     * @return true if and only if onHand is currently true
     */
    public boolean isOnHand() {
        return onHand;
    }

    /**
     * Setter method for onHand.
     *
     * @param aOnHand the new value for onHand
     */
    public void setOnHand(boolean aOnHand) {
        onHand = aOnHand;
    }

    /**
     * Access method for itemStatus.
     *
     * @return the current value of itemStatus
     */
    public int getItemStatus() {
        return itemStatus;
    }

    /**
     * Setter method for itemStatus.
     *
     * @param aItemStatus the new value for itemStatus
     */
    public void setItemStatus(int aItemStatus) {
        itemStatus = aItemStatus;
    }

    /**
     * Access method for originalPurchasingSizeGroups.
     *
     * @return the current value of originalPurchasingSizeGroups
     */
    public OriginalPurchasingSizeGroups getOriginalPurchasingSizeGroups() {
        return originalPurchasingSizeGroups;
    }

    /**
     * Setter method for originalPurchasingSizeGroups.
     *
     * @param aOriginalPurchasingSizeGroups the new value for originalPurchasingSizeGroups
     */
    public void setOriginalPurchasingSizeGroups(OriginalPurchasingSizeGroups aOriginalPurchasingSizeGroups) {
        originalPurchasingSizeGroups = aOriginalPurchasingSizeGroups;
    }

    /**
     * Access method for removalReasons.
     *
     * @return the current value of removalReasons
     */
    public RemovalReasons getRemovalReasons() {
        return removalReasons;
    }

    /**
     * Setter method for removalReasons.
     *
     * @param aRemovalReasons the new value for removalReasons
     */
    public void setRemovalReasons(RemovalReasons aRemovalReasons) {
        removalReasons = aRemovalReasons;
    }

    /**
     * Access method for purchasingSizes.
     *
     * @return the current value of purchasingSizes
     */
    public PurchasingSizes getPurchasingSizes() {
        return purchasingSizes;
    }

    /**
     * Setter method for purchasingSizes.
     *
     * @param aPurchasingSizes the new value for purchasingSizes
     */
    public void setPurchasingSizes(PurchasingSizes aPurchasingSizes) {
        purchasingSizes = aPurchasingSizes;
    }

    /**
     * Access method for corporateUsers.
     *
     * @return the current value of corporateUsers
     */
    public CorporateUsers getCorporateUsers() {
        return corporateUsers;
    }

    /**
     * Setter method for corporateUsers.
     *
     * @param aCorporateUsers the new value for corporateUsers
     */
    public void setCorporateUsers(CorporateUsers aCorporateUsers) {
        corporateUsers = aCorporateUsers;
    }

    /**
     * Access method for finalizedPurchases.
     *
     * @return the current value of finalizedPurchases
     */
    public FinalizedPurchases getFinalizedPurchases() {
        return finalizedPurchases;
    }

    /**
     * Setter method for finalizedPurchases.
     *
     * @param aFinalizedPurchases the new value for finalizedPurchases
     */
    public void setFinalizedPurchases(FinalizedPurchases aFinalizedPurchases) {
        finalizedPurchases = aFinalizedPurchases;
    }

    /**
     * Access method for finalizedPurchases2.
     *
     * @return the current value of finalizedPurchases2
     */
    public FinalizedPurchases getFinalizedPurchases2() {
        return finalizedPurchases2;
    }

    /**
     * Setter method for finalizedPurchases2.
     *
     * @param aFinalizedPurchases2 the new value for finalizedPurchases2
     */
    public void setFinalizedPurchases2(FinalizedPurchases aFinalizedPurchases2) {
        finalizedPurchases2 = aFinalizedPurchases2;
    }

    /**
     * Access method for distributionCentersSkus.
     *
     * @return the current value of distributionCentersSkus
     */
    public DistributionCentersSkus getDistributionCentersSkus() {
        return distributionCentersSkus;
    }

    /**
     * Setter method for distributionCentersSkus.
     *
     * @param aDistributionCentersSkus the new value for distributionCentersSkus
     */
    public void setDistributionCentersSkus(DistributionCentersSkus aDistributionCentersSkus) {
        distributionCentersSkus = aDistributionCentersSkus;
    }

    /**
     * Access method for inboundItems.
     *
     * @return the current value of inboundItems
     */
    public InboundItems getInboundItems() {
        return inboundItems;
    }

    /**
     * Setter method for inboundItems.
     *
     * @param aInboundItems the new value for inboundItems
     */
    public void setInboundItems(InboundItems aInboundItems) {
        inboundItems = aInboundItems;
    }

    /**
     * Compares the key for this instance with another ShoppingCartItems.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class ShoppingCartItems and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof ShoppingCartItems)) {
            return false;
        }
        ShoppingCartItems that = (ShoppingCartItems) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another ShoppingCartItems.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof ShoppingCartItems)) return false;
        return this.equalKeys(other) && ((ShoppingCartItems)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = getId();
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[ShoppingCartItems |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Integer.valueOf(getId()));
        return ret;
    }

}
