// Generated with g9.

package edu.iastate.sdmay2025.skus;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import edu.iastate.sdmay2025.distributioncentersskus.DistributionCentersSkus;
import edu.iastate.sdmay2025.products.Products;
import edu.iastate.sdmay2025.productsizes.ProductSizes;
import edu.iastate.sdmay2025.purchasingsizes.PurchasingSizes;

@Entity(name="skus")
public class Skus implements Serializable {

    /** Primary key. */
    protected static final String PK = "id";

    @Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(unique=true, nullable=false, precision=19)
    private long id;
    @Column(name="base_sku_id", precision=10)
    private int baseSkuId;
    @Column(nullable=false, precision=10)
    private int multiplier;
    @Column(length=1)
    private boolean archived;
    @Column(length=1)
    private boolean deleted;
    @ManyToOne(optional=false)
    @JoinColumn(name="product_id", nullable=false)
    private Products products;
    @ManyToOne(optional=false)
    @JoinColumn(name="product_size_id", nullable=false)
    private ProductSizes productSizes;
    @OneToMany(mappedBy="skus")
    private Set<DistributionCentersSkus> distributionCentersSkus;
    @OneToMany(mappedBy="skus")
    private Set<PurchasingSizes> purchasingSizes;

    /** Default constructor. */
    public Skus() {
        super();
    }

    /**
     * Access method for id.
     *
     * @return the current value of id
     */
    public long getId() {
        return id;
    }

    /**
     * Setter method for id.
     *
     * @param aId the new value for id
     */
    public void setId(long aId) {
        id = aId;
    }

    /**
     * Access method for baseSkuId.
     *
     * @return the current value of baseSkuId
     */
    public int getBaseSkuId() {
        return baseSkuId;
    }

    /**
     * Setter method for baseSkuId.
     *
     * @param aBaseSkuId the new value for baseSkuId
     */
    public void setBaseSkuId(int aBaseSkuId) {
        baseSkuId = aBaseSkuId;
    }

    /**
     * Access method for multiplier.
     *
     * @return the current value of multiplier
     */
    public int getMultiplier() {
        return multiplier;
    }

    /**
     * Setter method for multiplier.
     *
     * @param aMultiplier the new value for multiplier
     */
    public void setMultiplier(int aMultiplier) {
        multiplier = aMultiplier;
    }

    /**
     * Access method for archived.
     *
     * @return true if and only if archived is currently true
     */
    public boolean isArchived() {
        return archived;
    }

    /**
     * Setter method for archived.
     *
     * @param aArchived the new value for archived
     */
    public void setArchived(boolean aArchived) {
        archived = aArchived;
    }

    /**
     * Access method for deleted.
     *
     * @return true if and only if deleted is currently true
     */
    public boolean isDeleted() {
        return deleted;
    }

    /**
     * Setter method for deleted.
     *
     * @param aDeleted the new value for deleted
     */
    public void setDeleted(boolean aDeleted) {
        deleted = aDeleted;
    }

    /**
     * Access method for products.
     *
     * @return the current value of products
     */
    public Products getProducts() {
        return products;
    }

    /**
     * Setter method for products.
     *
     * @param aProducts the new value for products
     */
    public void setProducts(Products aProducts) {
        products = aProducts;
    }

    /**
     * Access method for productSizes.
     *
     * @return the current value of productSizes
     */
    public ProductSizes getProductSizes() {
        return productSizes;
    }

    /**
     * Setter method for productSizes.
     *
     * @param aProductSizes the new value for productSizes
     */
    public void setProductSizes(ProductSizes aProductSizes) {
        productSizes = aProductSizes;
    }

    /**
     * Access method for distributionCentersSkus.
     *
     * @return the current value of distributionCentersSkus
     */
    public Set<DistributionCentersSkus> getDistributionCentersSkus() {
        return distributionCentersSkus;
    }

    /**
     * Setter method for distributionCentersSkus.
     *
     * @param aDistributionCentersSkus the new value for distributionCentersSkus
     */
    public void setDistributionCentersSkus(Set<DistributionCentersSkus> aDistributionCentersSkus) {
        distributionCentersSkus = aDistributionCentersSkus;
    }

    /**
     * Access method for purchasingSizes.
     *
     * @return the current value of purchasingSizes
     */
    public Set<PurchasingSizes> getPurchasingSizes() {
        return purchasingSizes;
    }

    /**
     * Setter method for purchasingSizes.
     *
     * @param aPurchasingSizes the new value for purchasingSizes
     */
    public void setPurchasingSizes(Set<PurchasingSizes> aPurchasingSizes) {
        purchasingSizes = aPurchasingSizes;
    }

    /**
     * Compares the key for this instance with another Skus.
     *
     * @param other The object to compare to
     * @return True if other object is instance of class Skus and the key objects are equal
     */
    private boolean equalKeys(Object other) {
        if (this==other) {
            return true;
        }
        if (!(other instanceof Skus)) {
            return false;
        }
        Skus that = (Skus) other;
        if (this.getId() != that.getId()) {
            return false;
        }
        return true;
    }

    /**
     * Compares this instance with another Skus.
     *
     * @param other The object to compare to
     * @return True if the objects are the same
     */
    @Override
    public boolean equals(Object other) {
        if (!(other instanceof Skus)) return false;
        return this.equalKeys(other) && ((Skus)other).equalKeys(this);
    }

    /**
     * Returns a hash code for this instance.
     *
     * @return Hash code
     */
    @Override
    public int hashCode() {
        int i;
        int result = 17;
        i = (int)(getId() ^ (getId()>>>32));
        result = 37*result + i;
        return result;
    }

    /**
     * Returns a debug-friendly String representation of this instance.
     *
     * @return String representation of this instance
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("[Skus |");
        sb.append(" id=").append(getId());
        sb.append("]");
        return sb.toString();
    }

    /**
     * Return all elements of the primary key.
     *
     * @return Map of key names to values
     */
    public Map<String, Object> getPrimaryKey() {
        Map<String, Object> ret = new LinkedHashMap<String, Object>(6);
        ret.put("id", Long.valueOf(getId()));
        return ret;
    }

}
