import React from "react";
import ProcurementTool from "./components/ProcurementTool/ProcurementTool";
import DistributorCollapsable from "./components/PurchaseOrderTable/DistributorCollapsable";
import { Tabs, Layout } from "antd";

import "./App.css";

//Tab object export (documented in ant design)
const { TabPane } = Tabs;
const { Content } = Layout;

function callback(key: any) {}

//Top level application consisting of a layout and any components that should be rendered
const App: React.FC = () => {
  return (
    <Layout style={{ height: "100%" }}>
      <Content>
        {/*first { is escaping JSX {creating an object}}*/}
        {/*To center the tab bar we must use a flexbox which allows you to have multiple items that will dynamically align themselves based on how much space they have*/}
        {/*how much space to take up relative to other objects, justify, align objects based on row or column*/}
        <Tabs
          tabBarStyle={{ display: "flex", justifyContent: "center" }}
          defaultActiveKey="2"
          onChange={callback}
          style={{ height: "100%" }}
        >
          {/* deprecated <TabPane tab="Procurement Tool" key="1">
            <ProcurementTool />
          </TabPane> */}
          <TabPane
            style={{ overflow: "auto" }}
            tab="Purchase Order Table"
            key="2"
          >
            <DistributorCollapsable />
          </TabPane>
        </Tabs>
      </Content>
    </Layout>
  );
};

export default App;
