import axios from "axios";
import { Region } from "./components/ProcurementTool/ProcurementTool.api.types";
import { Error } from "./components/util/Error";
import { BASE_API_URL } from "./constants";

export const getAllRegions = async (): Promise<Region[]> => {
  const url = `${BASE_API_URL}/regions`;
  let response;
  try {
    response = await axios.get(url);
    const regionEntities: Region[] = response.data.map(
      (r: any) => new Region(r)
    );
    return regionEntities;
  } catch (e) {
    throw new Error({
      error: e,
      message:
        "There was a problem fetching regions. Try connecting to the ISU VPN or running backend locally",
    });
  }
};
