Documentation for algorithm



The algorithm we are currently using has a few basic steps.

1. Test train split: We split the data set into the first 2/3 for training, and the last 1/3 for testing. There is currently no validation data set. This can be added later depending on how much data we get. The larger the size of the training data set, the more accurate the algorithm can be, but the smaller the test data set, the less valid the results will be. A 2/3 1/3 split is pretty decent, this can be tuned a bit depending on what the people actually using this value later, but personally I wouldnt do less than 60% for training, and no more than 85%. In the algorithm, this is lines 29-31 (everything before this is just basic set up, importing modules, etc, and does not merit discussion).
2. The create data set method (lines 37-43). This basically sets up a numpy (python math module) array of inputs given some lookback value. The larger that value, the more the algorithm is allowed to look back. For example, if lookback is 10, and it is currently analyzing data for May 20, it can look at values from May 10 - May 20, in order to predict May 21.
3. The custom loss function: This is a work in progress and will be updated later on once it is done.
4. Creating the model: We are using an LSTM (explanations of this are the topic of masters thesis, and this document does not have the length neccesary to explain all inner workings, and will only provide a general overview) which is basically a special type of neural network with both long term and short term memory (Thus the name LSTM, Long Short Term Memory). We use 10 nodes in the LSTM layer connected to a fully connected (basically a normal neural network) layer with 1 output (the output **has to be** one number, because we are predicting one number).
5. Training and testing: Next we train and test the algorithm and get its accuracy scores.
6. Output: We print out the accuracy score, plot it with mathplotlib, and conver the data into javascript so it can be displayed.


### how to use

Right now, the algorithm is set up to take a command line argument. This argument should be the SKU you want to train a model for and send the results over to the API set up to store predictions. If no model is currently trained, it will pull the data for it, and train a new one. If there **is** a model for it, but it is more than one month old, it scraps it and trains a new one. If there is a model and it is less than a month old, it uses that model for predictions. It takes all past data into account when making the newest prediction. Because of this, predictions will be much more accurate, but potentially take longer. The lag time is under 10 seconds for most models, and training time is under 100 seconds for most models.

So, in order to train and get predictions for a SKU, lets say 1234, run:

`python3 non_api_version.py 1234`

This does **not** need to be run on the front end, only the backend. Ideally, a cronjob will be set up that will run this once every day for every SKU. If they are cycled, it will be pretty easy and have a very low server load. They should be staggered so updates do not need to be done all at once. For example, lets say we have 100 SKUs. If we train 1-20 on day one, 21-40 on day two, 41-60 on day three... and so on... Then X months later when they are out of date, when we run a cronjob that tries to pull predictions for all of them, only 1-20 will be updated today, then tomorrow, 21-40 will be updated, and so on. This way, although you still need to update predictions (and thus run the script) daily, you only ever need to update the **model** monthly. This was made to work all in the one script to make it easy for the user. You do not need to worry about which ones to update and when, just stagger when you **initially** run them for the first month, then after that run them **all** every day.
### storage

There are three levels of storage in our implementation:

1. storage of past stock levels. This was implemented for us basically, it is the database crafty is using to store historic stock data
2. storage of models. This is done on the server, all trained models are in the form "SKU.h5" where SKU is whatever the SKU that the model was trained on is. 
3. storage of predictions. The algorithm sends the latest days predictions to be stored in a seperate database so they can be pulled faster from the front end.