#!/usr/bin/python3
import csv
import matplotlib.pyplot as plt
import numpy as np
from numpy import nan
import sys
import pandas

import math
from keras.models import Sequential
from keras.layers import Dense
from keras.layers import LSTM
from sklearn.preprocessing import MinMaxScaler
from sklearn.metrics import mean_squared_error
from keras.models import load_model

import json
import urllib3
import json
from datetime import datetime
import time

from os import listdir
from os.path import isfile, join, getmtime

#import cgi
#import cgitb
#cgitb.enable()
#print("Content-type:text/html\r\n\r\n")



http = urllib3.PoolManager()

target_SKU = sys.argv[1]

onlyfiles = [f for f in listdir(".") if isfile(join(".", f)) if ".h5" == f[-3:]]

model = None

url = 'http://sdmay20-25.ece.iastate.edu:8080/sku_hist/' + target_SKU
response = http.request('GET', url)


data = json.loads(response.data)
print(data)
X = []
Y = []
for item in data:
       	utc_time = datetime.strptime(item["createdAt"][:10], "%Y-%m-%d")
       	epoch_time = (utc_time - datetime(1970, 1, 1)).total_seconds()
       	X += [epoch_time]
       	Y += [[item["count"]]]





dataset = Y
scaler = MinMaxScaler(feature_range=(0, 1))
dataset = scaler.fit_transform(dataset)


#print(dataset)
#for i in range(len(dataset)-1, 0, -1):
#	dataset[i][0] = dataset[i-1][0]-dataset[i][0]
#dataset = dataset[1:]
#print(dataset)

train_size = int(len(dataset) * 0.67)
test_size = len(dataset) - train_size
train, test = dataset[0:train_size,:], dataset[train_size:len(dataset),:]

# print(train)

# print(len(train), len(test))

def create_dataset(dataset, look_back=1):
	dataX, dataY = [], []
	for i in range(len(dataset)-look_back-1):
		a = dataset[i:(i+look_back), 0]
		dataX.append(a)
		dataY.append(dataset[i + look_back, 0])
	return np.array(dataX), np.array(dataY)

look_back = 10
trainX, trainY = create_dataset(train, look_back)
testX, testY = create_dataset(test, look_back)

# reshape input to be [samples, time steps, features]
trainX = np.reshape(trainX, (trainX.shape[0], 1, trainX.shape[1]))
testX = np.reshape(testX, (testX.shape[0], 1, testX.shape[1]))
# print(trainX, trainY)

if target_SKU + ".h5" not in onlyfiles or time.time() - getmtime(target_SKU + ".h5") > 60*60*24*30:
	print("no recent model found, creating a new one")
	model = Sequential()
	model.add(LSTM(10, input_shape=(1, look_back)))
	model.add(Dense(1))
	model.compile(optimizer='adam', loss="MSE")
	model.fit(trainX, trainY, epochs=100, batch_size=1, verbose=2)
	model.save(target_SKU + '.h5')
else:
	print("old model found, using that one instead")
	model = load_model(target_SKU + '.h5')


# make predictions
trainPredict = model.predict(trainX)
testPredict = model.predict(testX)

print(dataset[-15:])
print(testX[-1])

newest_prediction = int(scaler.inverse_transform(model.predict(np.array([[[i[0] for i in dataset[-10:]]]]))))

# invert predictions
trainPredict = scaler.inverse_transform(trainPredict)
trainY = scaler.inverse_transform([trainY])
testPredict = scaler.inverse_transform(testPredict)
testY = scaler.inverse_transform([testY])
# calculate root mean squared error
#trainScore = math.sqrt(mean_squared_error(trainY[0], trainPredict[:,0]))
#print('Train Score: %.2f RMSE' % (trainScore))
testScore = math.sqrt(mean_squared_error(testY[0], testPredict[:,0]))
#print('Test Score: %.2f RMSE' % (testScore))

print(newest_prediction)
response = http.request('POST', "http://sdmay20-25.ece.iastate.edu:8080/predictions/add", headers={'Content-Type': 'application/json'}, body=json.dumps({"sku_id": int(target_SKU), "qty_to_order": newest_prediction}))
print(response.data)


"""
# shift train predictions for plotting
trainPredictPlot = np.empty_like(dataset)
trainPredictPlot[:, :] = np.nan
trainPredictPlot[look_back:len(trainPredict)+look_back, :] = trainPredict
# shift test predictions for plotting
testPredictPlot = np.empty_like(dataset)
testPredictPlot[:, :] = np.nan
testPredictPlot[len(trainPredict)+(look_back*2)+1:len(dataset)-1, :] = testPredict

# plot baseline and predictions
plt.plot(scaler.inverse_transform(dataset))
plt.plot(trainPredictPlot)
plt.plot(testPredictPlot)
plt.show()
"""

def to_javascript(all_data, test, train):
	all_values_for_js = {"dataset": [], "test": [], "train": []}

	for value in all_data.tolist():
		if np.isnan(value[0]):
			all_values_for_js["dataset"] += [{"y": None}]
		else:
			all_values_for_js["dataset"] += [{"y": value[0]}]
	for value in test.tolist():
		if np.isnan(value[0]):
                        all_values_for_js["test"] += [{"y": None}]
		else:
			all_values_for_js["test"] += [{"y": value[0]}]
	for value in train.tolist():
		if np.isnan(value[0]):
                        all_values_for_js["train"] += [{"y": None}]
		else:
			all_values_for_js["train"] += [{"y": value[0]}]

	return json.dumps(all_values_for_js)
#print("A")
#print(to_javascript(scaler.inverse_transform(dataset), testPredictPlot, trainPredictPlot))


